from django.shortcuts import render
from accounts.forms import GroupForm, GroupAdminForm
from .forms import *
from django.contrib import messages
from django.http import JsonResponse
import json
from django.http.request import HttpRequest
from django.http.response import HttpResponse
from django.views.decorators.csrf import csrf_exempt
from django.shortcuts import redirect, render, reverse
from django.core import serializers
from .models import *
from accounts.models import *
from decimal import Decimal
import datetime
from accounts.forms import *
from django.template.defaultfilters import date
 

# Create your views here.
def group(request):
    form = GroupForm()
    return render(request, 'groups.html', {'form': form})

def error_404_view(request, exception):
    return render(request, '404.html')


def dashboard(request):

    cash_sales = Sales.objects.filter(created_by=request.user, sales_date__date=timezone.now().date(), sale_type="Cash Sale")
    credit_sales = Sales.objects.filter(created_by=request.user, sales_date__date=timezone.now().date(), sale_type="Credit Sale")
    wholesale = Sales.objects.filter(created_by=request.user, sales_date__date=timezone.now().date(), sale_type="wholesale")
    todays_stock = {}
    
    stock_approvals = Stock.objects.filter(created_by=request.user, trans_date__date=timezone.now().date())
    
    for stock_approval in stock_approvals:
        if stock_approval.productprice in todays_stock:
            todays_stock[stock_approval.productprice] += stock_approval.outward
        else:
            todays_stock[stock_approval.productprice] = stock_approval.outward
            
    #print(todays_stock)
            
    
    net_sales = 0
    momo = 0
    cash = 0
    cheque = 0
    total = 0
    discount = 0
    balance = 0
    
    credit_net_sales = 0
    credit_momo = 0
    credit_cash = 0
    credit_cheque = 0
    credit_total = 0
    credit_discount = 0
    credit_balance = 0
    
    wholesale_net_sales = 0
    wholesale_momo = 0
    wholesale_cash = 0
    wholesale_cheque = 0
    wholesale_total = 0
    wholesale_discount = 0
    wholesale_balance = 0
    
    for sale in cash_sales:
        net_sales += sale.net_amount
        momo += sale.momo
        cash += sale.cash
        cheque += sale.cheque
        total += sale.total_amount
        discount += sale.total_discount
        balance += sale.balance
        
    for sale in credit_sales:
        credit_net_sales += sale.net_amount
        credit_momo += sale.momo
        credit_cash += sale.cash
        credit_cheque += sale.cheque
        credit_total += sale.total_amount
        credit_discount += sale.total_discount
        credit_balance += sale.balance
        
    for sale in wholesale:
        wholesale_net_sales += sale.net_amount
        wholesale_momo += sale.momo
        wholesale_cash += sale.cash
        wholesale_cheque += sale.cheque
        wholesale_total += sale.total_amount
        wholesale_discount += sale.total_discount
        wholesale_balance += sale.balance
        
    context = {'cash_sales': cash_sales, 
               'net_sales': net_sales, 
               'momo': momo, 'cash': cash, 
               'cheque': cheque, 
               'total': total, 
               'discount': discount, 
               'credit_sales': credit_sales, 
               'credit_net_sales': credit_net_sales, 
               'credit_momo': credit_momo, 
               'credit_cash': credit_cash, 
               'credit_cheque': credit_cheque, 
               'credit_total': credit_total, 
               'credit_discount': credit_discount,
               'wholesale_net_sales': wholesale_net_sales, 
               'wholesale_momo':wholesale_momo,
               'wholesale_cash': wholesale_cash,
               'wholesale_cheque': wholesale_cheque,
               'wholesale_total': wholesale_total,
               'wholesale_discount': wholesale_discount,
               'balance': balance,
                'credit_balance':credit_balance,
                'wholesale_balance':wholesale_balance,
                'todays_stock':todays_stock,
               }

    return render(request, 'dashboard/home.html', context)




# Administration views
def companyProfile(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.company_profile or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    
    companyprofiles = CompanyProfile.objects.all()
    form = CompanyProfileForm(request.POST or None)
    
    if request.method == 'POST':
        form = CompanyProfileForm(request.POST)
        #print(form)
        if form.is_valid():
            
            created_by = form.save(commit=False)
            created_by.created_by = request.user
            created_by.save()
            
            #print('Company profile created successfully')
            messages.success(request, 'Company profile created successfully')
            return redirect(reverse('companyprofile'))
        else:
            messages.error(request, 'Company profile not created')
            #print('Company profile not created')
    context = {'form': form, 'companyprofiles': companyprofiles}
    return render(request, 'dashboard/administration/companyprofile.html', context)



def companylocation(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.company_location or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))

    form = CompanyLocationForm(request.POST or None)
    companylocations = CompanyLocation.objects.all()

    if request.method == 'POST':
        form = CompanyLocationForm(request.POST)

        if form.is_valid():
            companylocation = form.save(commit=False)
            companylocation.created_by = request.user
            companylocation.save(request.user)
            

            messages.success(request, 'Company location created successfully')
        else:
            messages.error(request, 'Company location not created')
    
    
    context = {'form': form, 'companylocations': companylocations}
    return render(request, 'dashboard/administration/companylocation.html', context)



def productcategory(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.product_category or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = ProductCategoryForm(request.POST or None)
    productcategories = ProductCategory.objects.all()
    if request.method == 'POST':
        form = ProductCategoryForm(request.POST)

        if form.is_valid():
            productcategory = form.save(commit=False)
            productcategory.created_by = request.user
            productcategory.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Product category created successfully')
        else:
            messages.error(request, 'Product category not created')
    
    
    context = {'form': form, 'productcategories': productcategories}
    return render(request, 'dashboard/administration/productcategory.html', context)




def products(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.products or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = ProductsForm(request.POST or None)
    products = Products.objects.all()
    baseUnits = Package.objects.all()
    categories = ProductCategory.objects.all()
    companylocations = CompanyLocation.objects.all()
    if request.method == 'POST':
        form = ProductsForm(request.POST)
        #print(form)
        if form.is_valid():
            product = form.save(commit=False)
            product.created_by = request.user
            product.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Product created successfully')
        else:
            messages.error(request, 'Product not created')
    
    
    context = {'form': form, 'products': products, 'baseUnits': baseUnits, 'categories':categories, 'companylocations':companylocations}
    return render(request, 'dashboard/administration/products.html', context)




def productPrice(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.product_prices or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = ProductPriceForm(request.POST or None)
    productprices = ProductPrice.objects.all()
    packages = Package.objects.all()
    products = Products.objects.all()
    companylocations = CompanyLocation.objects.all()
    if request.method == 'POST':
        form = ProductPriceForm(request.POST)

        if form.is_valid():
            productunit = form.save(commit=False)
            productunit.created_by = request.user
            stock = Stock(description="Initial Product Stock", invoicce_number="", inward=productunit.stockLevel, balance=productunit.stockLevel, productprice=productunit, created_by=request.user )
            productunit.save()
            stock.save()
            
            messages.success(request, 'Product price created successfully')
        else:
            messages.error(request, 'Product price not created')
    
    
    context = {'form': form, 'productprices': productprices, 'packages': packages, 'products':products, 'companylocations':companylocations	}
    return render(request, 'dashboard/administration/productprice.html', context)




def productStock(request):

    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.product_stocks or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productstocks = ProductPrice.objects.all()
    if request.method == 'POST':
        try:
            stocklevel_id = request.POST.get('id')

            stock_level = request.POST.get('stockLevel')
            
            if stock_level and stocklevel_id:
                
                productprice = ProductPrice.objects.get(id=stocklevel_id)
                current_stock_level = productprice.stockLevel
                
                stock_level = int(stock_level)
                
                difference = stock_level - current_stock_level
                
                stock = Stock(description="Stock Variance", invoicce_number="SV", inward=difference, productprice=productprice, balance=stock_level, created_by=request.user )
                ProductPrice.objects.filter(id=stocklevel_id).update(stockLevel=stock_level)
                stock.save()
                messages.success(request, "Stock Level Updated Successfully")
            else:
                messages.error(request, "Stock Level Not Updated")
        except:
            messages.error(request, "Access To This Resource Denied")

    context = {'productstocks': productstocks}
    return render(request, 'dashboard/administration/productstock.html', context)



def customers(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.customers or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = CustomersForm(request.POST or None)
    customers = Customer.objects.all()
    if request.method == 'POST':
        form = CustomersForm(request.POST)
        #print(form)
        if form.is_valid():
            customer = form.save(commit=False)

            customer.created_by = request.user
            customer.save()

            messages.success(request, 'Customer created successfully')
        else:
            messages.error(request, 'Customer not created')
    
    
    context = {'form': form, 'customers': customers}
    return render(request, 'dashboard/administration/customers.html', context)




def suppliers(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.suppliers or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = SupplierForm(request.POST or None)
    suppliers = Supplier.objects.all()
    if request.method == 'POST':
        form = SupplierForm(request.POST)
        #print(form)
        if form.is_valid():
            supplier = form.save(commit=False)
            supplier.created_by = request.user
            supplier.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Supplier created successfully')
        else:
            messages.error(request, 'Supplier not created')
    
    
    context = {'form': form, 'suppliers': suppliers}
    return render(request, 'dashboard/administration/suppliers.html', context)


# def roles(request):
#     form = RoleForm()
#     roles = Roles.objects.all()
#     context = {'form': form, 'roles':roles}
#     return render(request, 'dashboard/administration/roles.html', context)


def bankAccounts(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.bank_accounts or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = BankAccountForm(request.POST or None)
    bankaccounts = BankAccounts.objects.all()
    banks = Bank.objects.all()
    if request.method == 'POST':
        form = BankAccountForm(request.POST)
        #print(form)
        if form.is_valid():
            bankaccount = form.save(commit=False)
            bankaccount.created_by = request.user
            bankaccount.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Bank account created successfully')
        else:
            messages.error(request, 'Bank account not created')
    
    
    context = {'form': form, 'bankaccounts': bankaccounts, 'banks': banks}
    return render(request, 'dashboard/administration/bankaccounts.html', context)




def PaletCoding(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.product_prices or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = PaletForm(request.POST or None)
    colors = Colors.objects.all()
    palets = BatchPaleting.objects.all()
    products = ProductPrice.objects.all()
    if request.method == 'POST':
        form = PaletForm(request.POST)
        #print(form)
        if form.is_valid():
            paletcoding = form.save(commit=False)
            paletcoding.created_by = request.user
            paletcoding.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Palet coding created successfully')
        else:
            messages.error(request, 'Palet coding not created')
    
    
    context = {'form': form, 'colors': colors, 'palets': palets, 'products':products}
    
    
    return render(request, 'dashboard/administration/paletcoding.html', context)





def package(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.package or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = PackageForm(request.POST or None)
    packages = Package.objects.all()
    if request.method == 'POST':
        form = PackageForm(request.POST)
        #print(form)
        if form.is_valid():
            package = form.save(commit=False)
            package.created_by = request.user
            package.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Package created successfully')
        else:
            messages.error(request, 'Package not created')
    
    
    context = {'form': form, 'packages': packages}
    return render(request, 'dashboard/reference/package.html', context)




def colors(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.product_prices or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = ColorsForm(request.POST or None)
    colors = Colors.objects.all()
    if request.method == 'POST':
        form = ColorsForm(request.POST)
        #print(form)
        if form.is_valid():
            color = form.save(commit=False)
            color.created_by = request.user
            color.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Package created successfully')
        else:
            messages.error(request, 'Package not created')
    
    
    context = {'form': form, 'colors': colors}
    return render(request, 'dashboard/reference/color.html', context)





def expenseType(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.expense_type or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = ExpenseTypeForm(request.POST or None)
    expensetypes = ExpenseType.objects.all()
    if request.method == 'POST':
        form = ExpenseTypeForm(request.POST)
        #print(form)
        if form.is_valid():
            expensetype = form.save(commit=False)
            expensetype.created_by = request.user
            expensetype.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Expense type created successfully')
        else:
            messages.error(request, 'Expense type not created')
    
    
    context = {'form': form, 'expensetypes': expensetypes}
    return render(request, 'dashboard/reference/expencetype.html', context)



def bank(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.bank or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = BankForm(request.POST or None)
    banks = Bank.objects.all()
    if request.method == 'POST':
        form = BankForm(request.POST)
        #print(form)
        if form.is_valid():
            bank = form.save(commit=False)
            bank.created_by = request.user
            bank.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Bank created successfully')
        else:
            messages.error(request, 'Bank not created')
    
    
    context = {'form': form, 'banks': banks}
    return render(request, 'dashboard/reference/bank.html', context)



def paymentMode(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.payment_method or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = PaymentModeForm(request.POST or None)
    paymentmodes = PaymentMode.objects.all()
    if request.method == 'POST':
        form = PaymentModeForm(request.POST)
        #print(form)
        if form.is_valid():
            paymentmode = form.save(commit=False)
            paymentmode.created_by = request.user
            paymentmode.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Payment mode created successfully')
        else:
            messages.error(request, 'Payment mode not created')
    
    
    context = {'form': form, 'paymentmodes': paymentmodes}
    return render(request, 'dashboard/reference/paymentmode.html', context)



def transactionType(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.bank_transaction_type or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    
    form = TransactionTypeForm(request.POST or None)
    transactiontypes = BankTransactionType.objects.all()
    
    if request.method == 'POST':
        form = TransactionTypeForm(request.POST)
        #print(form)
        if form.is_valid():
            transactiontype = form.save(commit=False)
            transactiontype.created_by = request.user
            transactiontype.save(request.user)
            
            #print('Form is valid')
            messages.success(request, 'Transaction type created successfully')
        else:
            messages.error(request, 'Transaction type not created')
    
    
    context = {'form': form, 'transactiontypes': transactiontypes}
    return render(request, 'dashboard/reference/transactiontype.html', context)







# Transaction ID Generator
#@csrf_exempt
def generate_sales_id():
        timestamp = str(int(time.time()))
       #transaction_id = 'PD-' + timestamp
        transaction_id = 'PD-' 
        return transaction_id
    
    
def generate_stock_transfer_id():
        timestamp = str(int(time.time()))
        #transaction_id = 'ST-' + timestamp
        transaction_id = 'ST-' 
        return transaction_id
    
    
def generate_wholesale_id():
        timestamp = str(int(time.time()))
        #transaction_id = 'WS-' + timestamp
        transaction_id = 'WS-' 
        return transaction_id
    
    
def generate_credit_sale_id():
        timestamp = str(int(time.time()))
        #transaction_id = 'CS-' + timestamp
        transaction_id = 'CS-'
        return transaction_id
    
    
    
# Transactions  
# Retail Sale    
def cashSaleTransaction(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.cash_sale or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.filter(sale_type='retail')
    users = Acount_User.objects.all()
    context = {'productsprices': productsprices, 'users': users}
    
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("cashSaleTransaction"))
        
        count = 0
        gloabal_transaction_id = ""
        for data in json_data:
            count += 1
            if count > 1:
                break
            
            customer = json_data[data]['customer']
            customer_phone = json_data[data]['customer_phone']
            total_amount = json_data[data]['total']
            total_discount = json_data[data]['total_discount']
            net_amount = json_data[data]['net_total']
            selling_price = json_data[data]['selling_price']
            paid_amount = json_data[data]['total_paid']
            cheque_number = json_data[data]['cheque_number']
            cheque_date = json_data[data]['cheque_date']
            bank = json_data[data]['bank']
            #bank_branch = json_data[data]['bank_branch']
            momo = json_data[data]['momo_amount']
            cash = json_data[data]['cash_amount']
            cheque = json_data[data]['cheque_amount']
            visa = json_data[data]['visa_amount']
            balance = json_data[data]['balance']
            payee_name = json_data[data]['payee_name']
            discount_authorizer = json_data[data]['discount_authorizer']
            id = json_data[data]['id']
            
            # cash segmentations
            cedi1 = int(json_data[data]['cedi1'])
            cedi2 = int(json_data[data]['cedi2'])
            cedi5 = int(json_data[data]['cedi5'])
            cedi10 = int(json_data[data]['cedi10'])
            cedi20 = int(json_data[data]['cedi20'])
            cedi50 = int(json_data[data]['cedi50'])
            cedi100 = int(json_data[data]['cedi100'])
            cedi200 = int(json_data[data]['cedi200'])
            gp10 = int(json_data[data]['gp10'])
            gp20 = int(json_data[data]['gp20'])
            gp50 = int(json_data[data]['gp50'])
            
            id = int(id)
            if id:
                productprice = ProductPrice.objects.get(id=id)
            else:
                return JsonResponse({'error': 'Product not found'}, status=400)
            
            created_by = request.user
            
            if total_amount == "": total_amount = 0
            else: total_amount = Decimal(total_amount)
            
            if total_discount == "": total_discount = 0
            else: total_discount = Decimal(total_discount)
            
            if net_amount == "": net_amount = 0
            else: net_amount = Decimal(net_amount)
            
            if paid_amount == "": paid_amount = 0
            else: paid_amount = Decimal(paid_amount)
                
            if momo == "": momo = 0 
            else: momo = Decimal(momo)
            
            if cash == "": cash = 0
            else: cash = Decimal(cash)
            
            if cheque == "": cheque = 0
            else: cheque = Decimal(cheque)
            
            if visa == "": visa = 0
            else: visa = Decimal(visa)
            
            
            if balance == "": balance = 0
            else: balance = Decimal(balance) 
            #print(cheque, visa, momo, cash, balance, total_amount, total_discount, net_amount, paid_amount, cheque_number, cheque_date, bank, payee_name, created_by)
            sales = Sales(customer=customer, 
                          selling_price=selling_price, 
                          balance=balance, 
                          total_amount=total_amount, 
                          payee_name=payee_name, 
                          total_discount=total_discount, 
                          net_amount=net_amount, 
                          paid_amount=paid_amount, 
                          cheque_number=cheque_number, 
                          bank=bank, 
                          momo=momo, 
                          cash=cash, 
                          cheque=cheque, 
                          visa=visa, 
                          created_by=created_by, 
                          discount_authorizer=discount_authorizer, 
                          sale_type='Cash Sale', 
                          company_location=productprice.companylocation,
                          cedi1 = cedi1,
                          cedi2 = cedi2,
                          cedi5 = cedi5,
                          cedi10 = cedi10,
                          cedi20 = cedi20,
                          cedi50 = cedi50,
                          cedi100 = cedi100,
                          cedi200 = cedi200,
                          gp10 = gp10,
                          gp20 = gp20,
                          gp50 = gp50,
                          )
            new_sales_id = generate_sales_id()
            sales.save()
            sales_id = new_sales_id+str(sales.id)
            Sales.objects.filter(id=sales.id).update(sales_id=sales_id)
  
            gloabal_transaction_id = sales_id
        
        for item in json_data:
            #print(len(item))
            product = json_data[item]['product_name']
            package = json_data[item]['package_name']
            quantity = json_data[item]['qty']
            unit_price = json_data[item]['selling_price']
            discount = json_data[item]['discount']
            total = json_data[item]['unit_total']
            id = json_data[item]['id']
            id = int(id) 
            
            if quantity == "": quantity = 0
            else : quantity = int(quantity)
            
            if unit_price == "": unit_price = 0
            else: unit_price = Decimal(unit_price)
            
            if discount == "": discount = 0
            else: discount = Decimal(discount)
            
            if total == "": total = 0
            else: total = Decimal(total)
            #print(product, quantity, unit_price, discount, total)
            salesItem = SalesItem(product=product, package=package, unit_price=unit_price, total=total, unit_discount=discount, sales=sales, qty=quantity, created_by=request.user, productprice_id=id)
            salesItem.save()
        

        customer_exist = CustomerData.objects.filter(phone=customer_phone)
        if customer_exist:
            pass
        else:
            new_data = CustomerData(name=customer, phone=customer_phone)
            new_data.save()
            
        for item in json_data:   
            qty = json_data[item]['qty']
            qty = int(qty)
            id = json_data[item]['id']
            id = int(id)

            try:
                productprice = ProductPrice.objects.get(id=id)
                if productprice:
                    current_stock = productprice.stockLevel - qty
                    ProductPrice.objects.filter(id=id).update(stockLevel=current_stock)
                    
                    stock = Stock(description="Cash Sale", invoicce_number=gloabal_transaction_id, outward=qty, productprice=productprice, balance=current_stock, created_by=request.user )
                    stock.save()
            except ProductPrice.DoesNotExist:
                return JsonResponse({'error': 'Product does not exist'}, status=400)
            
            
        return JsonResponse({'status': 'success'})
    
    return render(request, 'dashboard/transaction/cashsales.html', context)





# Stock Approvals By Stock Manager
def approve_stock(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.can_approve_stock or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    
    sales = Sales.objects.filter(status = False)
    colors = Colors.objects.all()
    batch_numbers = BatchPaleting.objects.filter(active=True)
  
    if request.method == "POST":
        
        id = request.POST.get('id') 
        
        unapprovedSales = Sales.objects.filter(id=id).first()
        unapprovedsalesItems = unapprovedSales.salesitem_set.all()
        stock_is_approved = Stock.objects.filter(invoicce_number = unapprovedSales.sales_id)
                
        if stock_is_approved:
            #print("I'm am in stock control already")
            Sales.objects.filter(id=id).update(status=True)  #
            messages.error(request, 'Stock has already been deducted!')
            
            return redirect(reverse('approve_stock'))
            
        for sales_items in unapprovedsalesItems:

            productprice = ProductPrice.objects.get(id=sales_items.productprice_id)
            
            current_stock = int(productprice.stockLevel) - int(sales_items.qty)
            
            ProductPrice.objects.filter(id=sales_items.productprice_id).update(stockLevel=current_stock)
            
            stock = Stock(description=unapprovedSales.sale_type, invoicce_number=unapprovedSales.sales_id, outward=sales_items.qty, productprice=productprice, balance=current_stock, created_by=request.user )
            stock.save()
        
        Sales.objects.filter(id=id).update(status=True, status_approved_by=request.user, stock_approval_date=timezone.now())
        
        user_activity = UserActivitiesReport(user=request.user, activity=f'Approved Stock {unapprovedSales.sales_id}')
        user_activity.save()
        messages.success(request, 'Stock Approved')

        return redirect(reverse('approve_stock'))
   
        
    context = {'sales':sales, 'colors':colors, 'batch_numbers':batch_numbers}

    return render(request, 'dashboard/transaction/approve_stock.html', context)



def reject_stock(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.can_approve_stock or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))

    if request.method == "POST":  
        id = request.POST.get('id') 
        
        unapprovedSales = Sales.objects.filter(id=id).first()
        
        if unapprovedSales:
            
            user_activity = UserActivitiesReport(user=request.user, activity=f'Rejected a Sale {unapprovedSales.sales_id}')
            unapprovedSales.delete()
            user_activity.save()
            messages.success(request, 'Stock Rejected')
            
            return redirect(reverse('approve_stock'))

    return redirect(reverse('approve_stock'))




def approve_stock_paleting(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.can_approve_stock or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    

  
    if request.method == "POST":
        
        id = request.POST.get('id') 

        return redirect(reverse('approve_stock'))
    
    return render(request, 'dashboard/transaction/approve_stock.html')







def approve_protocol_stock(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.can_approve_stock or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    
    sales = Protocol.objects.filter(status = False)
    
    
    if request.method == "POST":
        
        id = request.POST.get('id') 
        
        # print(id)
        unapprovedSales = Protocol.objects.filter(id=id).first()
        unapprovedsalesItems = unapprovedSales.protocolsaleitem_set.all()
        stock_is_approved = Stock.objects.filter(invoicce_number = unapprovedSales.sales_id)
    
        #print(stock_is_approved)
        if stock_is_approved:
            #print("I'm am in stock control already")
            Protocol.objects.filter(id=id).update(status=True)  #
            messages.error(request, 'Stock has already been deducted!')
            
            return redirect(reverse('approve_protocol_stock'))
             
        else: 
            #print("I'm now here")            
            for sales_items in unapprovedsalesItems:

                productprice = ProductPrice.objects.get(id=sales_items.productprice_id)
                
                current_stock = int(productprice.stockLevel) - int(sales_items.qty)
                
                ProductPrice.objects.filter(id=sales_items.productprice_id).update(stockLevel=current_stock)
                
                stock = Stock(description="Protocol", invoicce_number=unapprovedSales.sales_id, outward=sales_items.qty, productprice=productprice, balance=current_stock, created_by=request.user )
                stock.save()
            
            Protocol.objects.filter(id=id).update(status=True, status_approved_by=request.user, stock_approval_date=timezone.now())
            
            user_activity = UserActivitiesReport(user=request.user, activity=f'Approved Protocol {unapprovedSales.sales_id}')
            user_activity.save()
            messages.success(request, 'Stock Approved')

            return redirect(reverse('approve_protocol_stock'))
   
        
    context = {'sales':sales}

    return render(request, 'dashboard/transaction/protocol_stock_approval.html', context)









#Credit Sale Transaction
def creditSaleTransaction(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.credit_sale or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.all()
    customers = Customer.objects.all()
    users = Acount_User.objects.all()
    comments = approval_comment.objects.all()
    
    context = {'productsprices': productsprices, 'users': users, 'customers': customers, 'comments': comments}
    
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("creditSaleTransaction"))
        
        gloabal_transaction_id = ""
        count = 0
        for data in json_data:
            count += 1
            if count > 1:
                break
            
            customer = json_data[data]['customer']
            total_amount = json_data[data]['total']
            total_discount = json_data[data]['total_discount']
            net_amount = json_data[data]['net_total']
            selling_price = json_data[data]['selling_price']
            paid_amount = json_data[data]['total_paid']
            cheque_number = json_data[data]['cheque_number']
            cheque_date = json_data[data]['cheque_date']
            bank = json_data[data]['bank']
            momo = json_data[data]['momo_amount']
            cash = json_data[data]['cash_amount']
            cheque = json_data[data]['cheque_amount']
            visa = json_data[data]['visa_amount']
            balance = json_data[data]['balance']
            payee_name = json_data[data]['payee_name']
            discount_authorizer = json_data[data]['discount_authorizer']
            credit_customer = json_data[data]['credit_customer']
            created_by = request.user
            
            
            id = json_data[data]['id']
            id = int(id)
            if id:
                productprice = ProductPrice.objects.get(id=id)
            else:
                return JsonResponse({'error': 'Product does not exits'}, status=400)
            
            try: 
                credit_customer = Customer.objects.get(id=credit_customer)
            except Customer.DoesNotExist:
                return JsonResponse({'error': 'Customer does not exist'}, status=400)
            
            
            
            if total_amount == "": total_amount = 0
            else: total_amount = Decimal(total_amount)
            
            if total_discount == "": total_discount = 0
            else: total_discount = Decimal(total_discount)
            
            if net_amount == "": net_amount = 0
            else: net_amount = Decimal(net_amount)
            
            if paid_amount == "": paid_amount = 0
            else: paid_amount = Decimal(paid_amount)
                
            if momo == "": momo = 0 
            else: momo = Decimal(momo)
            
            if cash == "": cash = 0
            else: cash = Decimal(cash)
            
            if cheque == "": cheque = 0
            else: cheque = Decimal(cheque)
            
            if visa == "": visa = 0
            else: visa = Decimal(visa)
            
            
            if balance == "": balance = 0
            else: balance = Decimal(balance) 
            
            #print((balance*-1)+credit_customer.total_credit > credit_customer.creditLimit)
            #print((balance*-1)+(credit_customer.total_credit*-1))
            if (balance*-1)+(credit_customer.total_credit*-1) > credit_customer.creditLimit:
                #print('Credit Limit Exceeded')
                return JsonResponse({'error': "Customer's Credit Limit Exceeded"}, status=400)
            
            
            credit_net_amount = credit_customer.total_credit + Decimal(balance)
            Customer.objects.filter(id=credit_customer.id).update(total_credit=credit_net_amount, total_paid=credit_customer.total_paid+Decimal(paid_amount))
            sales = Sales(customer=customer, selling_price=selling_price, balance=balance, total_amount=total_amount, payee_name=payee_name, total_discount=total_discount, net_amount=net_amount, paid_amount=paid_amount, cheque_number=cheque_number, bank=bank, momo=momo, cash=cash, cheque=cheque, visa=visa, created_by=created_by, discount_authorizer=discount_authorizer, sale_type='Credit Sale', company_location=productprice.companylocation, credit_customer=credit_customer)
            new_sales_id = generate_credit_sale_id()
            sales.save()
            sales_id = new_sales_id+str(sales.id)
            Sales.objects.filter(id=sales.id).update(sales_id=sales_id)
            gloabal_transaction_id = sales_id
        
        for item in json_data:
            #print(len(item))
            product = json_data[item]['product_name']
            package = json_data[item]['package_name']
            quantity = json_data[item]['qty']
            unit_price = json_data[item]['selling_price']
            discount = json_data[item]['discount']
            total = json_data[item]['unit_total']
            id = json_data[item]['id']
            id = int(id)
            
            if quantity == "": quantity = 0
            else : quantity = int(quantity)
            
            if unit_price == "": unit_price = 0
            else: unit_price = Decimal(unit_price)
            
            if discount == "": discount = 0
            else: discount = Decimal(discount)
            
            if total == "": total = 0
            else: total = Decimal(total)
            #print(product, quantity, unit_price, discount, total)
            salesItem = SalesItem(product=product, package=package, unit_price=unit_price, total=total, unit_discount=discount, sales=sales, qty=quantity, created_by=request.user, productprice_id=id)
            salesItem.save()
        
        
        for item in json_data:   
            qty = json_data[item]['qty']
            qty = int(qty)
            id = json_data[item]['id']
            id = int(id)

            try:
                productprice = ProductPrice.objects.get(id=id)
                if productprice:
                    current_stock = productprice.stockLevel - qty
                    ProductPrice.objects.filter(id=id).update(stockLevel=current_stock)
                    
                    stock = Stock(description="Credit Sale", invoicce_number=gloabal_transaction_id, outward=qty, productprice=productprice, balance=current_stock, created_by=request.user )
                    stock.save()
            except ProductPrice.DoesNotExist:
                return JsonResponse({'error': 'Product does not exist'}, status=400)
            
            
        return JsonResponse({'status': 'success'})
    
    return render(request, 'dashboard/transaction/creditsales.html', context)




# Initiated Credit Sale Transaction

def CreditSaleApprovalTransaction(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.credit_sale or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.all()
    customers = Customer.objects.all()
    users = Acount_User.objects.all()
    approval_comments = approval_comment.objects.all()
    
    context = {'productsprices': productsprices, 'users': users, 'customers': customers, 'approval_comments': approval_comments}
    
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("CreditSaleApprovalTransaction"))
        
        count = 0
        for data in json_data:
            count += 1
            if count > 1:
                break
            
            customer = json_data[data]['customer']
            total_amount = json_data[data]['total']
            total_discount = json_data[data]['total_discount']
            net_amount = json_data[data]['net_total']
            selling_price = json_data[data]['selling_price']
            paid_amount = json_data[data]['total_paid']
            cheque_number = json_data[data]['cheque_number']
            cheque_date = json_data[data]['cheque_date']
            bank = json_data[data]['bank']
            momo = json_data[data]['momo_amount']
            cash = json_data[data]['cash_amount']
            cheque = json_data[data]['cheque_amount']
            visa = json_data[data]['visa_amount']
            balance = json_data[data]['balance']
            payee_name = json_data[data]['payee_name']
            discount_authorizer = json_data[data]['discount_authorizer']
            credit_authorizer = json_data[data]['credit_authorizer']
            credit_customer = json_data[data]['credit_customer']
            created_by = request.user
            
            id = json_data[data]['id']
            id = int(id)
            if id:
                productprice = ProductPrice.objects.get(id=id)
            else:
                return JsonResponse({'error': 'Product does not exits'}, status=400)
            
            try: 
                credit_customer = Customer.objects.get(id=credit_customer)
            except Customer.DoesNotExist:
                return JsonResponse({'error': 'Customer does not exist'}, status=400)
            
            
            
            if total_amount == "": total_amount = 0
            else: total_amount = Decimal(total_amount)
            
            if total_discount == "": total_discount = 0
            else: total_discount = Decimal(total_discount)
            
            if net_amount == "": net_amount = 0
            else: net_amount = Decimal(net_amount)
            
            if paid_amount == "": paid_amount = 0
            else: paid_amount = Decimal(paid_amount)
                
            if momo == "": momo = 0 
            else: momo = Decimal(momo)
            
            if cash == "": cash = 0
            else: cash = Decimal(cash)
            
            if cheque == "": cheque = 0
            else: cheque = Decimal(cheque)
            
            if visa == "": visa = 0
            else: visa = Decimal(visa)
            
            
            if balance == "": balance = 0
            else: balance = Decimal(balance) 
            
            #((balance*-1)+credit_customer.total_credit > credit_customer.creditLimit)
            #print((balance*-1)+(credit_customer.total_credit*-1))
            if (balance*-1)+(credit_customer.total_credit*-1) > credit_customer.creditLimit:
                #print('Credit Limit Exceeded')
                return JsonResponse({'error': "Customer's Credit Limit Exceeded"}, status=400)
            
            
            #credit_net_amount = credit_customer.total_credit + Decimal(balance)
            #Customer.objects.filter(id=credit_customer.id).update(total_credit=credit_net_amount, total_paid=credit_customer.total_paid+Decimal(paid_amount))
            sales = CreditSaleApproval(customer=customer, selling_price=selling_price, balance=balance, total_amount=total_amount, payee_name=payee_name, total_discount=total_discount, net_amount=net_amount, paid_amount=paid_amount, cheque_number=cheque_number, bank=bank, momo=momo, cash=cash, cheque=cheque, visa=visa, created_by=created_by, discount_authorizer=discount_authorizer, sale_type='Credit Sale', company_location=productprice.companylocation, credit_customer=credit_customer, credit_authorizer=credit_authorizer)
            new_sales_id = generate_credit_sale_id()
            sales.save()
            sales_id = new_sales_id+str(sales.id)
            CreditSaleApproval.objects.filter(id=sales.id).update(sales_id=sales_id)
        
        for item in json_data:
            #print(len(item))
            product = json_data[item]['product_name']
            package = json_data[item]['package_name']
            quantity = json_data[item]['qty']
            unit_price = json_data[item]['selling_price']
            discount = json_data[item]['discount']
            total = json_data[item]['unit_total']
            id = json_data[item]['id']
            id = int(id)
            
            if quantity == "": quantity = 0
            else : quantity = int(quantity)
            
            if unit_price == "": unit_price = 0
            else: unit_price = Decimal(unit_price)
            
            if discount == "": discount = 0
            else: discount = Decimal(discount)
            
            if total == "": total = 0
            else: total = Decimal(total)
            #print(product, quantity, unit_price, discount, total)
            salesItem = CreditSaleApprovalItems(product=product, package=package, unit_price=unit_price, total=total, unit_discount=discount, sales=sales, qty=quantity, created_by=request.user, productprice_id=id)
            salesItem.save()
        
        
        # for item in json_data:   
        #     qty = json_data[item]['qty']
        #     qty = int(qty)
        #     id = json_data[item]['id']
        #     id = int(id)

        #     try:
        #         productprice = ProductPrice.objects.get(id=id)
        #         if productprice:
        #             current_stock = productprice.stockLevel - qty
        #             ProductPrice.objects.filter(id=id).update(stockLevel=current_stock)
                    
        #             #stock = Stock(description="Credit Sale", invoicce_number=gloabal_transaction_id, outward=qty, productprice=productprice, balance=current_stock, created_by=request.user )
        #             stock.save()
        #     except ProductPrice.DoesNotExist:
        #         return JsonResponse({'error': 'Product does not exist'}, status=400)
            
            
        return JsonResponse({'status': 'success'})
    
    return render(request, 'dashboard/transaction/creditsales.html', context)




def credit_sale_approval(request):
    
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.credit_sale_approval_report or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    
    sales = CreditSaleApproval.objects.all()
    form = CreditSaleApprovalForm()
    approvalform = approvalCommentForm()
    comments = approval_comment.objects.all()
    context = {'sales': sales, 'form':form, 'approvalform':approvalform, 'comments':comments}
    
    
    if request.method == "POST":
        
        #try:
        status = request.POST.get('status') 
        id = request.POST.get('id') 
        comment = request.POST.get('comments')
        
        
        unapprovedSales = CreditSaleApproval.objects.filter(id=id).first()
        unapprovedsalesItems = unapprovedSales.creditsaleapprovalitems_set.all()
        customer = Customer.objects.filter(id=unapprovedSales.credit_customer.id).last()
        form = CreditSaleApprovalForm(request.POST or None, instance=unapprovedSales)
        
        credit_sales_for_customer = Sales.objects.filter(credit_customer=customer)
        
        net_total = 0
        for credit_sales in credit_sales_for_customer:
            net_total+=credit_sales.net_amount
        
        #print(net_total)
        #print(customer)
        
        if form.is_valid():
            
            if status == "Approve":
                #print()
                credit_net_amount = net_total + Decimal(unapprovedSales.net_amount)
                #total_paid=customer.total_paid+Decimal(unapprovedSales.paid_amount)
                #Customer.objects.filter(id=customer.id).update(total_credit=credit_net_amount, total_paid=total_paid)
                Customer.objects.filter(id=customer.id).update(total_credit=credit_net_amount)
                
                sales = Sales(customer=unapprovedSales.customer, selling_price=unapprovedSales.selling_price, balance=unapprovedSales.balance, 
                                total_amount=unapprovedSales.total_amount, payee_name=unapprovedSales.payee_name, total_discount=unapprovedSales.total_discount, 
                                net_amount=unapprovedSales.net_amount, paid_amount=unapprovedSales.paid_amount, cheque_number=unapprovedSales.cheque_number, bank=unapprovedSales.bank, momo=unapprovedSales.momo, 
                                cash=unapprovedSales.cash, cheque=unapprovedSales.cheque, visa=unapprovedSales.visa, created_by=unapprovedSales.created_by, discount_authorizer=unapprovedSales.discount_authorizer, 
                                sale_type='Credit Sale', company_location=unapprovedSales.company_location, credit_customer=unapprovedSales.credit_customer, sales_id=unapprovedSales.sales_id
                                )
                sales.save()
                
                
                
                for sales_items in unapprovedsalesItems:
                    salesItem = SalesItem(product=sales_items.product, package=sales_items.package, unit_price=sales_items.unit_price, total=sales_items.total, unit_discount=sales_items.unit_discount, sales=sales, qty=sales_items.qty, created_by=sales_items.created_by, productprice_id=sales_items.productprice_id)
                    salesItem.save()
                    
                    #print(sales_items.product, sales_items.package, sales_items.total, sales_items.qty, sales)
                    #productprice = ProductPrice.objects.get(id=sales_items.productprice_id)
                    #print("Product Price", productprice.stockLevel)
                    #current_stock = int(productprice.stockLevel) - int(sales_items.qty)
                    #print("Current Stock", current_stock)
                    #ProductPrice.objects.filter(id=sales_items.productprice_id).update(stockLevel=current_stock)
                    
                    #stock = Stock(description="Credit Sale", invoicce_number=unapprovedSales.sales_id, outward=sales_items.qty, productprice=productprice, balance=current_stock, created_by=unapprovedSales.created_by )
                    #stock.save()
                
                approved_by = form.save(commit=False)
                approved_by.approved_rejected_by = request.user
                approved_by.save()
                messages.success(request, 'Credit Sale Approved')
                
            else:
                approved_by = form.save(commit=False)
                approved_by.approved_rejected_by = request.user
                approved_by.save()   
                messages.success(request, 'Credit Sale Not Approved')
            return redirect(reverse('credit_sale_approval'))
        else:
            messages.error(request, form.errors.as_text())
            return redirect(reverse('credit_sale_approval'))
        # except:
        #     messages.error(request, 'Oppps! Something went wrong. Please try again.')
        #     return redirect(reverse('credit_sale_approval'))
            
    
    return render(request, 'dashboard/transaction/approve_credit_sale.html', context)
 
 
 
 
def create_comments(request):
    if request.method == "GET":
        messages.error(request, 'Method not allowed')
    
    data = json.loads(request.body)
    comment = approval_comment()
    comment.comments = data['id_comments']
    comment.save()
    #print(comment)
    return JsonResponse({'status': 'success'})



# Stock Transfer
def stockTransferTransaction(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.stock_transfer or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    companylocations = CompanyLocation.objects.all()
    context = {'companylocations': companylocations}
    
    
    if request.method == "POST":
        #print("Request here")
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("stockTransferTransaction"))
        
        global_transaction_id = ""
        count = 0
        for data in json_data:
            count += 1
            if count > 1:
                break
            
            customer = json_data[data]['customer']
            from_location = json_data[data]['from_companylocation']
            to_location = json_data[data]['to_companylocation']
            total_amount = json_data[data]['total']
            total_discount = json_data[data]['total_discount']
            net_amount = json_data[data]['net_total']
            selling_price = json_data[data]['selling_price']
            paid_amount = json_data[data]['total_paid']
            cheque_number = json_data[data]['cheque_number']
            cheque_date = json_data[data]['cheque_date']
            bank = json_data[data]['bank']
            #bank_branch = json_data[data]['bank_branch']
            momo = json_data[data]['momo_amount']
            cash = json_data[data]['cash_amount']
            cheque = json_data[data]['cheque_amount']
            visa = json_data[data]['visa_amount']
            balance = json_data[data]['balance']
            payee_name = json_data[data]['payee_name']
            discount_authorizer = json_data[data]['discount_authorizer']
            product = json_data[data]['product_name']
            package = json_data[data]['package_name']
            quantity = json_data[data]['qty']
            unit_price = json_data[data]['selling_price']
            id = json_data[data]['id']
            id = int(id)
            created_by = request.user
            
            from_location = json_data[data]['from_companylocation']
            to_location = json_data[data]['to_companylocation']
            from_company_location = CompanyLocation.objects.get(id=from_location)
            to_company_location = CompanyLocation.objects.get(id=to_location)
            
            if total_amount == "": total_amount = 0
            else: total_amount = Decimal(total_amount)
            
            if total_discount == "": total_discount = 0
            else: total_discount = Decimal(total_discount)
            
            if net_amount == "": net_amount = 0
            else: net_amount = Decimal(net_amount)
            
            if paid_amount == "": paid_amount = 0
            else: paid_amount = Decimal(paid_amount)
                
            if momo == "": momo = 0 
            else: momo = Decimal(momo)
            
            if cash == "": cash = 0
            else: cash = Decimal(cash)
            
            if cheque == "": cheque = 0
            else: cheque = Decimal(cheque)
            
            if visa == "": visa = 0
            else: visa = Decimal(visa)
            
            if balance == "": balance = 0
            else: balance = Decimal(balance) 

            stock = stockTransfer(product=product, package=package, unit_price=unit_price, qty=quantity, from_company=from_company_location, to_company=to_company_location, customer=customer, selling_price=selling_price, balance=balance, total_amount=total_amount, payee_name=payee_name, total_discount=total_discount, net_amount=net_amount, paid_amount=paid_amount, cheque_number=cheque_number, bank=bank, momo=momo, cash=cash, cheque=cheque, visa=visa, created_by=created_by, discount_authorizer=discount_authorizer, productprice_id=id)
            new_sales_id = generate_stock_transfer_id()
            stock.save()
            sales_id = new_sales_id+str(stock.id)
            stockTransfer.objects.filter(id=stock.id).update(stock_transfer_id=sales_id)
            global_transaction_id = sales_id
        
        count = 0
        for item in json_data:  
            count+=1
            if count > 1:
                break 
            qty = json_data[item]['qty']
            qty = int(qty)
            id = json_data[item]['id']
            id = int(id)

            from_location = json_data[data]['from_companylocation']
            to_location = json_data[data]['to_companylocation']
            from_company_location = CompanyLocation.objects.get(id=from_location)
            to_company_location = CompanyLocation.objects.get(id=to_location)
            
            try:  
                #print("I'm in try block") 
                productprice = ProductPrice.objects.get(id=id)
                #stock_product = ProductPrice.objects.get(id=id)
                
                product_to_update_id = ProductPrice.objects.get(product=productprice.product, package=productprice.package, companylocation=to_company_location)
                
                if productprice and product_to_update_id:
                    productprice_level = productprice.stockLevel - qty
                    if product_to_update_id.sale_type == 'retail':
                        product_to_update = (product_to_update_id.stockLevel + int(qty*product_to_update_id.qty_in_package))
                    else:
                        product_to_update = (product_to_update_id.stockLevel + qty)
                    
                    ProductPrice.objects.filter(id=id).update(stockLevel=productprice_level)
                    ProductPrice.objects.filter(id=product_to_update_id.id).update(stockLevel=product_to_update)
                    
                    stock1 = Stock(description="Stock Transfer", invoicce_number=global_transaction_id, inward=qty, productprice=product_to_update_id, balance=product_to_update, created_by=request.user )
                    stock2 = Stock(description="Stock Transfer", invoicce_number=global_transaction_id, outward=qty, productprice=productprice, balance=productprice_level, created_by=request.user )
                    user_activity = UserActivitiesReport(user=request.user, activity=f'Transfered Stock {productprice.product} from {from_company_location.name} to {to_company_location.name} - {global_transaction_id} {qty}={product_to_update}')
                    stock1.save()
                    stock2.save()
                    user_activity.save()
            except ProductPrice.DoesNotExist:   

                return JsonResponse({'error': 'The product does not exist in the targeted location'}, status=400)
        #print("'I'm Here lst")    
        return JsonResponse({'status': 'success'})
    
    return render(request, 'dashboard/transaction/stock_transfer.html', context)




# wholesale sales 

def wholeSaleTransaction(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.cash_sale or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.filter(sale_type='wholesale')
    users = Acount_User.objects.all()
    context = {'productsprices': productsprices, 'users': users}
    
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("wholeSaleTransaction"))
        
        gloabal_transaction_id = ""
        count = 0
        for data in json_data:
            count += 1
            if count > 1:
                break

            customer = json_data[data]['customer']
            total_amount = json_data[data]['total']
            total_discount = json_data[data]['total_discount']
            net_amount = json_data[data]['net_total']
            selling_price = json_data[data]['selling_price']
            paid_amount = json_data[data]['total_paid']
            cheque_number = json_data[data]['cheque_number']
            cheque_date = json_data[data]['cheque_date']
            bank = json_data[data]['bank']
            momo = json_data[data]['momo_amount']
            cash = json_data[data]['cash_amount']
            cheque = json_data[data]['cheque_amount']
            visa = json_data[data]['visa_amount']
            balance = json_data[data]['balance']
            payee_name = json_data[data]['payee_name']
            discount_authorizer = json_data[data]['discount_authorizer']
            id = json_data[data]['id']
            id = int(id)
            if id:
                productprice = ProductPrice.objects.get(id=id)
            else:
                return JsonResponse({'error': 'Product does not exist'}, status=400)
            
            
            created_by = request.user
            
            if total_amount == "": total_amount = 0
            else: total_amount = Decimal(total_amount)
            
            if total_discount == "": total_discount = 0
            else: total_discount = Decimal(total_discount)
            
            if net_amount == "": net_amount = 0
            else: net_amount = Decimal(net_amount)
            
            if paid_amount == "": paid_amount = 0
            else: paid_amount = Decimal(paid_amount)
                
            if momo == "": momo = 0 
            else: momo = Decimal(momo)
            
            if cash == "": cash = 0
            else: cash = Decimal(cash)
            
            if cheque == "": cheque = 0
            else: cheque = Decimal(cheque)
            
            if visa == "": visa = 0
            else: visa = Decimal(visa)
            
            
            if balance == "": balance = 0
            else: balance = Decimal(balance) 
            sales = Sales(customer=customer, selling_price=selling_price, balance=balance, total_amount=total_amount, payee_name=payee_name, total_discount=total_discount, net_amount=net_amount, paid_amount=paid_amount, cheque_number=cheque_number, bank=bank, momo=momo, cash=cash, cheque=cheque, visa=visa, created_by=created_by, discount_authorizer=discount_authorizer, sale_type='wholesale', company_location=productprice.companylocation)
            new_sales_id = generate_wholesale_id()
            sales.save()
            sales_id = new_sales_id+str(sales.id)
            Sales.objects.filter(id=sales.id).update(sales_id=sales_id)
            gloabal_transaction_id = sales_id
            
            
        for item in json_data:
            product = json_data[item]['product_name']
            package = json_data[item]['package_name']
            quantity = json_data[item]['qty']
            unit_price = json_data[item]['selling_price']
            discount = json_data[item]['discount']
            total = json_data[item]['unit_total']
            id = json_data[item]['id']
            id = int(id)
            
            if quantity == "": quantity = 0
            else : quantity = int(quantity)
            
            if unit_price == "": unit_price = 0
            else: unit_price = Decimal(unit_price)
            
            if discount == "": discount = 0
            else: discount = Decimal(discount)
            
            if total == "": total = 0
            else: total = Decimal(total)
            saleitem = SalesItem(product=product, package=package, unit_price=unit_price, total=total, unit_discount=discount, sales=sales, qty=quantity, created_by=request.user, productprice_id=id)
            saleitem.save()
        
        
        for item in json_data:   
            qty = json_data[item]['qty']
            qty = int(qty)
            id = json_data[item]['id']
            id = int(id)

            try:
                productprice = ProductPrice.objects.get(id=id)
                if productprice:
                    current_stock = productprice.stockLevel - qty
                    ProductPrice.objects.filter(id=id).update(stockLevel=current_stock)
                    
                    stock = Stock(description="wholesale", invoicce_number=gloabal_transaction_id, outward=qty, productprice=productprice, balance=current_stock, created_by=request.user )
                    stock.save()
            except ProductPrice.DoesNotExist:
                return JsonResponse({'error': 'Product does not exist'}, status=400)
            
            
        return JsonResponse({'status': 'success'})
    
    return render(request, 'dashboard/transaction/wholesale.html', context)








#Sales Update 
def sale_update(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.sale_update or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.all()
    users = Acount_User.objects.all()
    customers = Customer.objects.all()
    context = {'productsprices': productsprices, 'users': users, 'customers':customers}
    
    if request.method == "POST":
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("sale_update"))
        
        counter = 0
        for key in json_data:
            sales_id = json_data[key]['sales_id']
            counter +=1
            #print(counter)
            if counter == 1:
                break
#
        try:
            sale_to_update = Sales.objects.get(sales_id=sales_id)
            salesitems = sale_to_update.salesitem_set.all()
            new_total = 0
            new_net_total = 0
            new_discount_total = 0
            
            # print(salesitems)
        
            current_total = sale_to_update.total_amount
            current_net_total = sale_to_update.net_amount
            current_total_discount = sale_to_update.total_discount
            
            
            for sales in salesitems:
                #print(type(sales.productprice_id))
                for key in json_data:
                    if int(json_data[key]['productprice_id']) == sales.productprice_id:
                        # sales.update(unit_price = Decimal(json_data[key]['new_price']))
                        SalesItem.objects.filter(id=sales.id).update(unit_price=Decimal(json_data[key]['new_price']), total=(int(sales.qty)*Decimal(json_data[key]['new_price'])))
                        new_price = Decimal(json_data[key]['new_price'])
                        new_price = Decimal(new_price)
                        user_activity = UserActivitiesReport(user=request.user, activity=f'Updated Unit Price of {sales_id} {sales.product} {sales.package} from {sales.unit_price} to {new_price}')
                        user_activity.save()
                    else:
                        pass

            salesitems = sale_to_update.salesitem_set.all()        
            for sales in salesitems:
                new_total += (sales.unit_price * int(sales.qty))
                new_discount_total += (sales.unit_discount * int(sales.qty))
            new_net_total += new_total - new_discount_total
            Sales.objects.filter(sales_id=sales_id).update(total_amount = new_total, net_amount = new_net_total, total_discount = new_discount_total)
                
            #print(current_net_total, new_net_total)
            
            if sale_to_update.sale_type == "Credit Sale":
                credit_customer = sale_to_update.credit_customer
                credit_customer = Customer.objects.filter(id=credit_customer.id).last()
                Customer.objects.filter(id=credit_customer.id).update(total_credit = (credit_customer.total_credit - current_net_total + new_net_total))
        except sale_to_update.DoesNotExist:
            return JsonResponse({'Sale does not exist':'Sale does not exist'}, safe=False, status=404)
        

    
    return render(request, 'dashboard/transaction_update/sale_update.html', context)





def sale_discount_update(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.sale_update or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.all()
    users = Acount_User.objects.all()
    customers = Customer.objects.all()
    context = {'productsprices': productsprices, 'users': users, 'customers':customers}
    
    if request.method == "POST":
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("sale_update"))
        
        counter = 0
        for key in json_data:
            sales_id = json_data[key]['sales_id']
            counter +=1
            #print(counter)
            if counter == 1:
                break
#
        try:
            sale_to_update = Sales.objects.get(sales_id=sales_id)
            salesitems = sale_to_update.salesitem_set.all()
            new_total = 0
            new_net_total = 0
            new_discount_total = 0
            
            # print(salesitems)
        
            current_total = sale_to_update.total_amount
            current_net_total = sale_to_update.net_amount
            current_total_discount = sale_to_update.total_discount
            
            
            for sales in salesitems:
                #print(type(sales.productprice_id))
                for key in json_data:
                    if int(json_data[key]['productprice_id']) == sales.productprice_id:
                        # sales.update(unit_price = Decimal(json_data[key]['new_price']))
                        SalesItem.objects.filter(id=sales.id).update(unit_discount=Decimal(json_data[key]['new_discount']), total=(int(sales.qty)*Decimal(json_data[key]['new_discount'])))
                        new_discount = Decimal(json_data[key]['new_discount'])
                        new_discount = Decimal(new_discount)
                        user_activity = UserActivitiesReport(user=request.user, activity=f'Updated Discount of {sales_id} {sales.product} {sales.package} from {sales.unit_discount} to {new_discount}')
                        user_activity.save()
                    else:
                        pass
            sale_to_update = Sales.objects.get(sales_id=sales_id)
            salesitems = sale_to_update.salesitem_set.all()        
            for sales in salesitems:
                # print(sales.total, sales.unit_discount)
                new_total += (sales.unit_price * int(sales.qty))
                new_discount_total += (sales.unit_discount * int(sales.qty))
            new_net_total += new_total - new_discount_total
            Sales.objects.filter(sales_id=sales_id).update(total_amount = new_total, net_amount = new_net_total, total_discount = new_discount_total)
                
            #print(current_net_total, new_net_total)
            
            if sale_to_update.sale_type == "Credit Sale":
                credit_customer = sale_to_update.credit_customer
                credit_customer = Customer.objects.filter(id=credit_customer.id).last()
                Customer.objects.filter(id=credit_customer.id).update(total_credit = (credit_customer.total_credit - current_net_total + new_net_total))
        except sale_to_update.DoesNotExist:
            return JsonResponse({'Sale does not exist':'Sale does not exist'}, safe=False, status=404)
        

    
    return render(request, 'dashboard/transaction_update/sale_update.html', context)





#Stock Purchase Update 
def stock_purchase_update(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.sale_update or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.all()
    customers = Supplier.objects.all()
    context = {'productsprices': productsprices, 'customers':customers}
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("stock_purchase_update"))
        
        counter = 0
        for key in json_data:
            stock_purchase_id = json_data[key]['stock_purchase_id']
            counter +=1
            #print(counter)
            if counter == 1:
                break
#
        # try:
        
        sale_to_update = stockPurchase.objects.get(id=stock_purchase_id)
        salesitems = sale_to_update.stockpurchaseitem_set.all()
        new_total = 0
        new_net_total = 0
        new_discount_total = 0
        
        # print(salesitems)
    
        current_total = sale_to_update.total_amount
        current_net_total = sale_to_update.net_amount
        current_total_discount = sale_to_update.total_discount
        #print(current_total, current_net_total, current_total_discount)
        
        for sales in salesitems:
            #print(type(sales.productprice_id))
            for key in json_data:
                if int(json_data[key]['productprice_id']) == sales.productprice_id:
                    # sales.update(unit_price = Decimal(json_data[key]['new_price']))
                    #print(json_data[key]['new_price'])
                    StockPurchaseItem.objects.filter(id=sales.id).update(unit_price=Decimal(json_data[key]['new_price']), total=(int(sales.qty)*Decimal(json_data[key]['new_price'])))
                    new_price = Decimal(json_data[key]['new_price'])
                    new_price = Decimal(new_price)
                    user_activity = UserActivitiesReport(user=request.user, activity=f'Updated Stock Purchase Unit Price of {stock_purchase_id} {sales.product}{sales.package} from {sales.unit_price} to {new_price}')
                    user_activity.save()
                else:
                    pass

        salesitems = sale_to_update.stockpurchaseitem_set.all()        
        for sales in salesitems:
            new_total += sales.total
            new_discount_total += sales.unit_discount
        new_net_total += new_total - new_discount_total
        stockPurchase.objects.filter(id=stock_purchase_id).update(total_amount = new_total, net_amount = new_net_total, total_discount = new_discount_total)
            
        
        
        credit_customer = sale_to_update.supplier
        supplier = Supplier.objects.filter(id=credit_customer.id).last()
        Supplier.objects.filter(id=supplier.id).update(credit = (supplier.credit - current_net_total + new_net_total))
        
            
        # except:
        #     return JsonResponse({'Sale does not exist':'Sale does not exist'}, safe=False, status=404)
        

    
    return render(request, 'dashboard/transaction_update/stock_purchase_update.html', context)





def getSalesById(request):
    id = request.GET.get('id')
    
    try:
        sales = Sales.objects.get(sales_id=id)
        salesitems = sales.salesitem_set.all()
    
        
        serialized_object = serializers.serialize('json', [sales, ])
        serialized_related_objects = serializers.serialize('json', salesitems)
        
        json_string = {
        'object': serialized_object,
        'related_objects': serialized_related_objects,
        }
        
        data = json.dumps(json_string)
        
        
        #print(data)
    except Sales.DoesNotExist:
        return JsonResponse({'error': 'Sale does not exist'}, status=400)
    
    return JsonResponse({'data':data }, status=200)






def getStockPurchaseById(request):
    id = request.GET.get('id')
    
    try:
        sales = stockPurchase.objects.get(id=id)
        salesitems = sales.stockpurchaseitem_set.all()
    
        
        serialized_object = serializers.serialize('json', [sales, ])
        serialized_related_objects = serializers.serialize('json', salesitems)
        
        json_string = {
        'object': serialized_object,
        'related_objects': serialized_related_objects,
        }
        
        data = json.dumps(json_string)
        
        
        #print(data)
    except Sales.DoesNotExist:
        return JsonResponse({'error': 'Sale does not exist'}, status=400)
    
    return JsonResponse({'data':data }, status=200)





# Return Sales

def return_sales(request):
    if request.method == 'POST':
        data = json.loads(request.body)
        id = data['id']
        #print(id)
        try: 
            sale = Sales.objects.get(id=id)
            salesitem = sale.salesitem_set.all()
            stock = Stock.objects.filter(invoicce_number=sale.sales_id)

        except Sales.DoesNotExist:
            return JsonResponse({'error': 'Sales does not exist'}, status=400)

        if not stock:
            return JsonResponse({'error': 'Sale has not been approved'}, status=400)
        
        
        for item in salesitem:
            productprice = ProductPrice.objects.get(id=item.productprice_id)
            #print(productprice.stockLevel)
            qty = item.qty
            current_stock = productprice.stockLevel + int(qty)
            ProductPrice.objects.filter(id=productprice.id).update(stockLevel=current_stock)
            stock = Stock(description="Stock Return", invoicce_number=sale.sales_id, inward=qty, productprice=productprice, balance=current_stock, created_by=request.user)
            user_activity = UserActivitiesReport(user=request.user, activity=f'Returned {sale.sales_id} {item.product} {qty}')
            stock.save()
            user_activity.save()
            
        sale.delete()
        
    return JsonResponse({'status': 'success'})





def return_protocol(request):
    if request.method == 'POST':
        data = json.loads(request.body)
        id = data['id']
        #print(id)
        try: 
            sale = Protocol.objects.get(id=id)
            salesitem = sale.protocolsaleitem_set.all()
            stock = Stock.objects.filter(invoicce_number=id)
        except Sales.DoesNotExist:
            return JsonResponse({'error': 'Sales does not exist'}, status=400)

        if not stock:
            return JsonResponse({'error': 'Sale has not been approved'}, status=400)
        
        
        for item in salesitem:
            productprice = ProductPrice.objects.get(id=item.productprice_id)
            #print(productprice.stockLevel)
            qty = item.qty
            current_stock = productprice.stockLevel + int(qty)
            ProductPrice.objects.filter(id=productprice.id).update(stockLevel=current_stock)
            stock = Stock(description="Stock Return", invoicce_number=sale.sales_id, inward=qty, productprice=productprice, balance=current_stock, created_by=request.user)
            user_activity = UserActivitiesReport(user=request.user, activity=f'Returned {sale.sales_id} {item.product} {qty}')
            stock.save()
            user_activity.save()
        sale.delete()
        
    return JsonResponse({'status': 'success'})




# Initiate a Credit Sale
def initiate_credit_sale(request):
    
    return render(request, 'dashboard/transaction/initiate_credit_sale.html')





# stock purchase
def stock_purchase(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.stock_purchase or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    companylocations = CompanyLocation.objects.all()
    suppliers = Supplier.objects.all()
    users = Acount_User.objects.all()
    banks = Bank.objects.all()
    context = {'companylocations': companylocations, 'suppliers': suppliers, 'users': users, 'banks': banks}
    
    
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("stock_purchase"))
            
        #print(json_data)
        count = 0
        for data in json_data:
            count += 1
            if count > 1:
                break
            
            total_amount = json_data[data]['total']
            total_discount = json_data[data]['total_discount']
            net_amount = json_data[data]['net_total']
            selling_price = json_data[data]['selling_price']
            paid_amount = json_data[data]['total_paid']
            cheque_number = json_data[data]['cheque_number']
            cheque_date = json_data[data]['cheque_date']
            bank = json_data[data]['bank']
            #bank_branch = json_data[data]['bank_branch']
            momo = json_data[data]['momo_amount']
            cash = json_data[data]['cash_amount']
            cheque = json_data[data]['cheque_amount']
            visa = json_data[data]['visa_amount']
            balance = json_data[data]['balance']
            payee_name = json_data[data]['payee_name']
            discount_authorizer = json_data[data]['discount_authorizer']
            product = json_data[data]['product_name']
            package = json_data[data]['package_name']
            quantity = json_data[data]['qty']
            unit_price = json_data[data]['selling_price']
            new_price = json_data[data]['new_price']
            supplier = json_data[data]['supplier']
            stock_purchase_id = json_data[data]['invoice_number']
            created_by = request.user
            
            
            from_location = json_data[data]['from_companylocation']
            
            from_company_location = CompanyLocation.objects.get(id=int(from_location))
            
            
            if total_amount == "": total_amount = 0
            else: total_amount = Decimal(total_amount)
            
            if total_discount == "": total_discount = 0
            else: total_discount = Decimal(total_discount)
            
            if net_amount == "": net_amount = 0
            else: net_amount = Decimal(net_amount)
            
            if paid_amount == "": paid_amount = 0
            else: paid_amount = Decimal(paid_amount)
                
            if momo == "": momo = 0 
            else: momo = Decimal(momo)
            
            if cash == "": cash = 0
            else: cash = Decimal(cash)
            
            if cheque == "": cheque = 0
            else: cheque = Decimal(cheque)
            
            if visa == "": visa = 0
            else: visa = Decimal(visa)
            
            if balance == "": balance = 0
            else: balance = Decimal(balance) 
            
            
            supplier = Supplier.objects.get(id=int(supplier))            
            #print(supplier)
            stockpurchase = stockPurchase(stock_purchase_id=stock_purchase_id, product=product, package=package, unit_price=unit_price, 
                                  qty=quantity, CompanyLocation=from_company_location, balance=balance, 
                                  total_amount=total_amount, payee_name=payee_name, 
                                  total_discount=total_discount, net_amount=net_amount, 
                                  paid_amount=paid_amount, cheque_number=cheque_number, bank=bank, 
                                  momo=momo, cash=cash, cheque=cheque, visa=visa, created_by=created_by, 
                                  discount_authorizer=discount_authorizer,
                                  supplier=supplier, cheque_date=cheque_date, 
                                  )
            stockpurchase.save()        
            balance = balance*-1         
            Supplier.objects.filter(id=supplier.id).update(credit=+balance, debit=+paid_amount)
            
            
            for item in json_data:
                product = json_data[item]['product_name']
                package = json_data[item]['package_name']
                quantity = json_data[item]['qty']
                unit_price = json_data[item]['selling_price']
                discount = json_data[item]['discount']
                total = json_data[item]['unit_total']
                new_price = json_data[item]['new_price']
                id = json_data[item]['id']
                id = int(id)
                
                if quantity == "": quantity = 0
                else : quantity = int(quantity)
                
                if unit_price == "": unit_price = 0
                else: unit_price = Decimal(unit_price)
                
                if discount == "": discount = 0
                else: discount = Decimal(discount)
                
                if total == "": total = 0
                else: total = Decimal(total)
                
                
                saleitem = StockPurchaseItem(product=product, package=package, unit_price=unit_price, new_selling_price=new_price, total=total, unit_discount=discount, sales=stockpurchase, qty=quantity, created_by=request.user, productprice_id=id)
                saleitem.save()
                product_stock = ProductPrice.objects.get(id=id)
                balance = product_stock.stockLevel + quantity
                old_stock = product_stock.stockLevel
                #print(f"New Stock: {quantity} Old Stock: {old_stock} and balance: {balance}")
                stock = Stock(description="Stock Purchase", invoicce_number=stock_purchase_id, inward=quantity, productprice=product_stock, balance=balance, created_by=request.user )
                user_activity = UserActivitiesReport(user=request.user, activity=f'Stock Purchase of {quantity}={balance} for {product} {stock_purchase_id}')
                stock.save()
                user_activity.save()
                ProductPrice.objects.filter(id=id).update(stockLevel=balance, selling_price=new_price)
                
                
            return JsonResponse({'status': 'success'})
    
    return render(request, 'dashboard/transaction/stock_purchase.html', context)





def cashsale_protocol(request):
    
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.protocol or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.filter(sale_type='retail')
    users = Acount_User.objects.all()
    context = {'productsprices': productsprices, 'users': users}
    
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("cashsale_protocol"))
            
        count = 0
        for data in json_data:
            count += 1
            if count > 1:
                break
            
            customer = json_data[data]['customer']
            total_amount = json_data[data]['total']
            total = json_data[data]['total']

            balance = json_data[data]['balance']
            id = json_data[data]['id']
            id = int(id)
            if id:
                productprice = ProductPrice.objects.get(id=id)
            else:
                return JsonResponse({'error': 'Product not found'}, status=400)
            
            created_by = request.user
            
            if total_amount == "": total_amount = 0
            else: total_amount = Decimal(total_amount)
        
                
            if balance == "": balance = 0
            else: balance = Decimal(balance) 
            
            if total == "": total = 0
            else: total = Decimal(total) 
            
            
            sales = Protocol(customer=customer, net_amount=total, created_by=created_by, company_location=productprice.companylocation, total_amount=total)
            
            sales.save()
            sales_id = 'PC'+str(sales.id)
            Protocol.objects.filter(id=sales.id).update(sales_id=sales_id)
  
            
        
        for item in json_data:
            product = json_data[item]['product_name']
            package = json_data[item]['package_name']
            quantity = json_data[item]['qty']
            unit_price = json_data[item]['selling_price']
            total = json_data[item]['unit_total']
            id = json_data[item]['id']
            id = int(id)
            
            if quantity == "": quantity = 0
            else : quantity = int(quantity)
            
            if unit_price == "": unit_price = 0
            else: unit_price = Decimal(unit_price)
            
            
            if total == "": total = 0
            else: total = Decimal(total)

            salesItem = ProtocolSaleItem(product=product, package=package, unit_price=unit_price, total=total, sales=sales, qty=quantity, created_by=request.user, productprice_id=id)
            salesItem.save()
        
        
        # for item in json_data:   
        #     qty = json_data[item]['qty']
        #     qty = int(qty)
        #     id = json_data[item]['id']
        #     id = int(id)

        #     try:
        #         productprice = ProductPrice.objects.get(id=id)
        #         if productprice:
        #             current_stock = productprice.stockLevel - qty
        #             ProductPrice.objects.filter(id=id).update(stockLevel=current_stock)
                    
        #             stock = Stock(description="Protocol", invoicce_number=sales_id, outward=qty, productprice=productprice, balance=current_stock, created_by=request.user )
        #             stock.save()
        #     except ProductPrice.DoesNotExist:
        #         return JsonResponse({'error': 'Product does not exist'}, status=400)
            
            
        return JsonResponse({'status': 'success'})
    
    return render(request, 'dashboard/transaction/cashsale_protocol.html', context)









# Wholesle Protocol

def wholesale_protocol(request):
    
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.protocol or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.filter(sale_type='wholesale')
    users = Acount_User.objects.all()
    context = {'productsprices': productsprices, 'users': users}
    
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("wholesale_protocol"))
        
        count = 0
        for data in json_data:
            count += 1
            if count > 1:
                break
            
            customer = json_data[data]['customer']
            total_amount = json_data[data]['total']
            total = json_data[data]['total']

            balance = json_data[data]['balance']
            id = json_data[data]['id']
            id = int(id)
            if id:
                productprice = ProductPrice.objects.get(id=id)
            else:
                return JsonResponse({'error': 'Product not found'}, status=400)
            
            created_by = request.user
            
            if total_amount == "": total_amount = 0
            else: total_amount = Decimal(total_amount)
        
                
            if balance == "": balance = 0
            else: balance = Decimal(balance) 
            
            if total == "": total = 0
            else: total = Decimal(total) 
            
            
            sales = Protocol(customer=customer, net_amount=total, created_by=created_by, company_location=productprice.companylocation, total_amount=total)
            
            sales.save()
            sales_id = 'WS'+str(sales.id)
            Protocol.objects.filter(id=sales.id).update(sales_id=sales_id)
  
            
        
        for item in json_data:
            product = json_data[item]['product_name']
            package = json_data[item]['package_name']
            quantity = json_data[item]['qty']
            unit_price = json_data[item]['selling_price']
            total = json_data[item]['unit_total']
            id = json_data[item]['id']
            id = int(id)
            
            if quantity == "": quantity = 0
            else : quantity = int(quantity)
            
            if unit_price == "": unit_price = 0
            else: unit_price = Decimal(unit_price)
            
            
            if total == "": total = 0
            else: total = Decimal(total)

            salesItem = ProtocolSaleItem(product=product, package=package, unit_price=unit_price, total=total, sales=sales, qty=quantity, created_by=request.user, productprice_id=id)
            salesItem.save()
        
        
        # for item in json_data:   
        #     qty = json_data[item]['qty']
        #     qty = int(qty)
        #     id = json_data[item]['id']
        #     id = int(id)

        #     try:
        #         productprice = ProductPrice.objects.get(id=id)
        #         if productprice:
        #             current_stock = productprice.stockLevel - qty
        #             ProductPrice.objects.filter(id=id).update(stockLevel=current_stock)
                    
        #             stock = Stock(description="Protocol", invoicce_number=sales_id, outward=qty, productprice=productprice, balance=current_stock, created_by=request.user )
        #             stock.save()
        #     except ProductPrice.DoesNotExist:
        #         return JsonResponse({'error': 'Product does not exist'}, status=400)
            
            
        return JsonResponse({'status': 'success'})
    
    return render(request, 'dashboard/transaction/wholesale_protocol.html', context)







# Receipts Generator

def receiptTransaction(request):
    sales = Sales.objects.all().last()
    salesItems = sales.salesitem_set.all()
    
    discount_sale = 0
    total_sales = 0
    
    for sale in salesItems:
        total_sales += (sale.unit_price * int(sale.qty)) - (sale.unit_discount * int(sale.qty))
        discount_sale += (sale.unit_discount * int(sale.qty))
        
    balance = total_sales - sales.paid_amount 
    
    # print(total_sales, discount_sale, balance) 
    company = CompanyProfile.objects.filter().first()
    context = {
        'sales': sales,
        'salesItems': salesItems,
        'company':company,
        'discount_sale':discount_sale,
        'total_sales':total_sales,
        'balance': balance,
    }
    return render(request, 'dashboard/transaction/receipt.html', context)



def printReceipt(request, id):
    
    # print(id)
    try:
        sales = Sales.objects.filter(id=id).first()
        salesItems = sales.salesitem_set.all()
        
        company = CompanyProfile.objects.filter().first()
        
        discount_sale = 0
        total_sales = 0
    
        for sale in salesItems:
            total_sales += (sale.unit_price * int(sale.qty)) - (sale.unit_discount * int(sale.qty))
            discount_sale += (sale.unit_discount * int(sale.qty))
            
        balance = total_sales - sales.paid_amount 
        context = {
            'sales': sales,
            'salesItems': salesItems,
            'company':company,
            'discount_sale':discount_sale,
            'total_sales':total_sales,
            'balance': balance,
        }
            
            
        
    except:
        messages.error(request, 'Receipt with this ID not found.')
        return redirect(reverse('salesReport'))
    
    return render(request, 'dashboard/transaction/printReceipt.html', context)


def WholesaleReceipt(request):
    sales = Sales.objects.all().last()
    salesItems = sales.salesitem_set.all()
    
    discount_sale = 0
    total_sales = 0
    
    for sale in salesItems:
        total_sales += (sale.unit_price * int(sale.qty)) - (sale.unit_discount * int(sale.qty))
        discount_sale += (sale.unit_discount * int(sale.qty))
        
    balance = total_sales - sales.paid_amount 
    
    company = CompanyProfile.objects.filter().first()
    context = {
        'sales': sales,
        'salesItems': salesItems,
        'company':company,
        'discount_sale':discount_sale,
        'total_sales':total_sales,
        'balance': balance,
    }
    

    return render(request, 'dashboard/transaction/whosaleRecipt.html', context)




def creditSaleReceipt(request):
    sales = CreditSaleApproval.objects.all().last()
    salesItems = sales.creditsaleapprovalitems_set.all()
    company = CompanyProfile.objects.filter().first()
    
    discount_sale = 0
    total_sales = 0
    for sale in salesItems:
        total_sales += (sale.unit_price * int(sale.qty)) - (sale.unit_discount * int(sale.qty))
        discount_sale += (sale.unit_discount * int(sale.qty))
        
    balance = total_sales - sales.paid_amount 
     
    
    company = CompanyProfile.objects.filter().first()
    context = {
        'sales': sales,
        'salesItems': salesItems,
        'company':company,
        'discount_sale':discount_sale,
        'total_sales':total_sales,
        'balance': balance,
    }
    return render(request, 'dashboard/transaction/credit_sale_receipt.html', context)









# Transacton Return Views

def sale_return(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.sale_return or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.all()
    users = Acount_User.objects.all()
    customers = Customer.objects.all()
    context = {'productsprices': productsprices, 'users': users, 'customers':customers}
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("sale_return"))
        
        counter = 0
        for key in json_data:
            sales_id = json_data[key]['sales_id']
            counter +=1
            #print(counter)
            if counter == 1:
                break
#       
        stock = Stock.objects.filter(invoicce_number=sales_id)
            
        if not stock:
            #print("I'm here")
            return JsonResponse({'Sale has not been approved':'Sale has not been approved'}, safe=False, status=404)
        
        
        try:

            sale_to_update = Sales.objects.get(sales_id=sales_id)
            salesitems = sale_to_update.salesitem_set.all()
            new_total = 0
            new_net_total = 0
            new_discount_total = 0
            
            current_net_total = sale_to_update.net_amount
            
            for sales in salesitems:
                #print(type(sales.productprice_id))
                for key in json_data:
                    if int(json_data[key]['productprice_id']) == sales.productprice_id:
                        
                        returned_stock = int(json_data[key]['new_price'])
                        old_stock = int(sales.qty)
                        product_price = ProductPrice.objects.filter(id=sales.productprice_id).last()

                        if old_stock > returned_stock:
                            new_stock = old_stock - returned_stock
                            stock_level = ProductPrice.objects.filter(id=sales.productprice_id).last().stockLevel    
                            current_Stock_level = stock_level + returned_stock

                            SalesItem.objects.filter(id=sales.id).update(qty=new_stock, total=(sales.unit_price*int(new_stock)))
                            user_activity = UserActivitiesReport(user=request.user, activity=f'Returned {returned_stock} out of {sales.qty} from {sales.product} {sales.package} Sale: {sales.sales_id}')
                            user_activity.save()
                            
                            ProductPrice.objects.filter(id=sales.productprice_id).update(stockLevel=current_Stock_level)
                            stock = Stock(description="Stock Return", invoicce_number=sales_id, inward=returned_stock, productprice=product_price, balance=current_Stock_level, created_by=request.user)
                            stock.save()
                    else:
                        pass

            salesitems = sale_to_update.salesitem_set.all()        
            for sales in salesitems:
                new_total += sales.total
                new_discount_total += sales.unit_discount
            new_net_total += new_total - new_discount_total
            Sales.objects.filter(sales_id=sales_id).update(total_amount = new_total, net_amount = new_net_total, total_discount = new_discount_total)
                
            #print(current_net_total, new_net_total)
            
            if sale_to_update.sale_type == "Credit Sale":
                credit_customer = sale_to_update.credit_customer
                credit_customer = Customer.objects.filter(id=credit_customer.id).last()
                Customer.objects.filter(id=credit_customer.id).update(total_credit = (credit_customer.total_credit - current_net_total + new_net_total))
        
        except sale_to_update.DoesNotExist:
            return JsonResponse({'Sale does not exist':'Sale does not exist'}, safe=False, status=404)
    
    return render(request, 'dashboard/transaction_return/sale_return.html', context)






def sale_return_one(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.sale_return or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("sale_return"))
            
        sales_id = json_data['sale_id']
        id = json_data['id']

        try:
            
            sale_to_update = Sales.objects.get(id=sales_id)
            sales_item = SalesItem.objects.filter(id=id).first()
            sales_items = SalesItem.objects.filter(id=id)
            
            stock = Stock.objects.filter(invoicce_number=sale_to_update.sales_id)
            
            if not stock:
                
                return JsonResponse({'Sale has not been approved':'Sale has not been approved'}, safe=False, status=404)
            
            # if len(sales_items) == 1:
            #     print("I'm here")
            #     return JsonResponse({'Sale does not exist':'Sale does not exist'}, safe=False, status=404)
            
            new_total = 0
            new_net_total = 0
            new_discount_total = 0
            qty_returnd = sales_item.qty
            product_price_id = sales_item.productprice_id
            # print(qty_returnd, product_price_id)
            product_price = ProductPrice.objects.filter(id=sales_item.productprice_id).last()

            # print("Posted")
                
            stock_level = ProductPrice.objects.filter(id=product_price_id).last().stockLevel 
            # print(stock_level)   
            current_Stock_level = int(stock_level) + int(qty_returnd)
            # print(current_Stock_level)
            
            sales_item.delete()
            
            user_activity = UserActivitiesReport(user=request.user, activity=f'Returned {qty_returnd} from {sales_item.product} {sales_item.package} Sale: {sale_to_update.sales_id}')
            user_activity.save()
            
            ProductPrice.objects.filter(id=int(product_price_id)).update(stockLevel=current_Stock_level)
            
            stock = Stock(description="Stock Return", invoicce_number=sales_id, inward=qty_returnd, productprice=product_price, balance=current_Stock_level, created_by=request.user)
            stock.save()
                    

            salesitems = sale_to_update.salesitem_set.all()        
            for sales in salesitems:
                new_total += sales.total
                new_discount_total += sales.unit_discount
            new_net_total += new_total - new_discount_total
            #print(new_net_total)
            Sales.objects.filter(id=sales_id).update(total_amount = new_total, net_amount = new_net_total, total_discount = new_discount_total)
                
            # print(new_net_total)
            
            
        except sale_to_update.DoesNotExist:
            return JsonResponse({'Sale does not exist':'Sale does not exist'}, safe=False, status=404)
    
    return JsonResponse({'Successful':'Successful'})








# Stock Purchase Return

def stock_purchase_return(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.sale_return or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.all()
    users = Acount_User.objects.all()
    suppliers = Supplier.objects.all()
    context = {'productsprices': productsprices, 'users': users, 'suppliers':suppliers}
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("stock_purchase_return"))
            
        counter = 0
        for key in json_data:
            sales_id = json_data[key]['sales_id']
            counter +=1
            #print(counter)
            if counter == 1:
                break
#
        # try:
        sale_to_update = stockPurchase.objects.get(id=sales_id)
        salesitems = sale_to_update.stockpurchaseitem_set.all()
        new_total = 0
        new_net_total = 0
        new_discount_total = 0
        
        current_net_total = sale_to_update.net_amount
        
        for sales in salesitems:
            #print(type(sales.productprice_id))
            for key in json_data:
                if int(json_data[key]['productprice_id']) == sales.productprice_id:
                    
                    returned_stock = int(json_data[key]['new_price'])
                    old_stock = int(sales.qty)
                    product_price = ProductPrice.objects.filter(id=sales.productprice_id).last()

                    if old_stock >= returned_stock:
                        new_stock = old_stock - returned_stock
                        stock_level = ProductPrice.objects.filter(id=sales.productprice_id).last().stockLevel    
                        current_Stock_level = stock_level - returned_stock

                        StockPurchaseItem.objects.filter(id=sales.id).update(qty=new_stock, total=(sales.unit_price*int(new_stock)))
                        user_activity = UserActivitiesReport(user=request.user, activity=f'Returned {returned_stock} out of {sales.qty} from {sales.product} {sales.package} Sale: {sales.sales_id}')
                        user_activity.save()
                        
                        ProductPrice.objects.filter(id=sales.productprice_id).update(stockLevel=current_Stock_level)
                        stock = Stock(description="Stock Purchase Return", invoicce_number=sales_id, outward=returned_stock, productprice=product_price, balance=current_Stock_level, created_by=request.user)
                        stock.save()
                else:
                    pass

        salesitems = sale_to_update.stockpurchaseitem_set.all()        
        for sales in salesitems:
            new_total += sales.total
            new_discount_total += sales.unit_discount
        new_net_total += new_total - new_discount_total
        stockPurchase.objects.filter(id=sales_id).update(total_amount = new_total, net_amount = new_net_total, total_discount = new_discount_total)
            
        #print(current_net_total, new_net_total)
        
        
        credit_customer = sale_to_update.supplier
        supplier = Supplier.objects.filter(id=credit_customer.id).last()
        Supplier.objects.filter(id=supplier.id).update(credit = (supplier.credit - current_net_total + new_net_total))
        
        # except sale_to_update.DoesNotExist:
        #     return JsonResponse({'Sale does not exist':'Sale does not exist'}, safe=False, status=404)
    
    return render(request, 'dashboard/transaction_return/stock_purchase_return.html', context)






def stock_requisition_return(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.sale_return or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    productsprices = ProductPrice.objects.all()
    users = Acount_User.objects.all()
    suppliers = Supplier.objects.all()
    context = {'productsprices': productsprices, 'users': users, 'suppliers':suppliers}
    
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("stock_purchase_return"))
            
        counter = 0
        for key in json_data:
            sales_id = json_data[key]['sales_id']
            counter +=1
            #print(counter)
            if counter == 1:
                break
#
        # try:
        supply_to = json_data['requested_info']['supply_to']
        on_account_of = json_data['requested_info']['on_account_of']
        srv_no = json_data['requested_info']['srv_no']
        date_requested = json_data['requested_info']['date_requested']
        product_owner = json_data['requested_info']['product_owner']
        recipient = json_data['requested_info']['recipient']
        cashier = json_data['requested_info']['cashier']
        stock_keeper = json_data['requested_info']['stock_keeper']

        sale_to_update = stockPurchase.objects.get(id=sales_id)
        salesitems = sale_to_update.stockpurchaseitem_set.all()
        new_total = 0
        new_net_total = 0
        new_discount_total = 0
        
        current_net_total = sale_to_update.net_amount
        for sales in salesitems:
            for key in json_data:
                if json_data[key] != json_data['requested_info']:
                    print('It worked')
                    if int(json_data[key]['productprice_id']) == sales.productprice_id:
                        print(int(json_data[key]['productprice_id']))
                        returned_stock = int(json_data[key]['new_price'])
                        old_stock = int(sales.qty)
                        product_price = ProductPrice.objects.filter(id=sales.productprice_id).last()

                        if old_stock >= returned_stock:
                            
                            new_stock = old_stock - returned_stock
                            stock_level = ProductPrice.objects.filter(id=sales.productprice_id).last().stockLevel    
                            current_Stock_level = stock_level - returned_stock

                            StockPurchaseItem.objects.filter(id=sales.id).update(qty=new_stock, total=(sales.unit_price*int(new_stock)))
                            user_activity = UserActivitiesReport(user=request.user, activity=f'Returned {returned_stock} out of {sales.qty} from {sales.product} {sales.package} Sale: {sales.sales_id}')
                            user_activity.save()
                            
                            ProductPrice.objects.filter(id=sales.productprice_id).update(stockLevel=current_Stock_level)
                            stock = Stock(description="Stock Requition Return", invoicce_number=sales_id, outward=returned_stock, productprice=product_price, balance=current_Stock_level, created_by=request.user)
                            stock.save()
                            
                            stock_requisition = StockRequisitionReturn(invoicce_number=sales_id, 
                                                                    qty=returned_stock, 
                                                                    productprice=product_price, 
                                                                    balance=current_Stock_level, 
                                                                    created_by=request.user, 
                                                                    supplied_to = supply_to,
                                                                    on_account_of = on_account_of,
                                                                    srv_no = srv_no,
                                                                    date = date_requested,
                                                                    product_owner = product_owner,
                                                                    recipient = recipient,
                                                                    cashier = cashier,
                                                                    stock_keeper = stock_keeper,
                                                                    )
                            stock_requisition.save()
                    else:
                        pass
                else:
                    pass 
                
        salesitems = sale_to_update.stockpurchaseitem_set.all()        
        for sales in salesitems:
            new_total += sales.total
            new_discount_total += sales.unit_discount
        new_net_total += new_total - new_discount_total
        stockPurchase.objects.filter(id=sales_id).update(total_amount = new_total, net_amount = new_net_total, total_discount = new_discount_total)
            
        #print(current_net_total, new_net_total)
        
        
        credit_customer = sale_to_update.supplier
        supplier = Supplier.objects.filter(id=credit_customer.id).last()
        Supplier.objects.filter(id=supplier.id).update(credit = (supplier.credit - current_net_total + new_net_total))
        
        # except sale_to_update.DoesNotExist:
        #     return JsonResponse({'Sale does not exist':'Sale does not exist'}, safe=False, status=404)
    
    return render(request, 'dashboard/transaction_return/stock_requisition.html', context)






# transaction Payment views

# Credit Sale Payment
def creditSalePayment(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.credit_sale_payment or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
        
    form = CreditSalePaymentForm()
    customers = Customer.objects.all()
    credit_sales = Sales.objects.filter(sale_type='credit')
    credit_sale_payments = CreditSalePayment.objects.all()
    company_locations = CompanyLocation.objects.all()
    banks = Bank.objects.all()
    payment_modes = PaymentMode.objects.all()
    users = Acount_User.objects.all()
    
    

    if request.method == 'POST':
        form = CreditSalePaymentForm(request.POST)
        if form.is_valid():
            amount = form.cleaned_data.get('amount')
            customer = form.cleaned_data.get('customer')
            amount = Decimal(amount)
            Customer.objects.filter(id=customer.id).update(total_paid=customer.total_paid+amount)
            
            created_by = form.save(commit=False)
            created_by.created_by = request.user
            created_by.save()
            messages.success(request, 'Credit sale payment successful')
            return redirect(reverse('creditSalePayment'))
        messages.error(request, form.errors.as_text())
        return redirect(reverse('creditSalePayment'))
            
        
    context = {
        'form': form,
        'customers':customers,
        'credit_sales':credit_sales,
        'credit_sale_payments':credit_sale_payments,
        'company_locations': company_locations,
        'banks':banks,
        'payment_modes':payment_modes,
        'users':users,
    }
    return render(request, 'dashboard/transaction_payment/creditSalePayment.html', context)





def creditSaleCashPayment(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.credit_sale_payment or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
        
    form = CreditCashPaymentForm()
    customers = Customer.objects.all()
    credit_sales = Sales.objects.filter(sale_type='credit')
    credit_sale_payments = CreditSalePayment.objects.all()
    company_locations = CompanyLocation.objects.all()
    banks = Bank.objects.all()
    payment_modes = PaymentMode.objects.all()
    users = Acount_User.objects.all()
    
    if request.method == 'POST':
        form = CreditCashPaymentForm(request.POST)

        if form.is_valid():
            amount = form.cleaned_data.get('amount')
            customer = form.cleaned_data.get('customer')
            amount = Decimal(amount)
            Customer.objects.filter(id=customer.id).update(total_paid=customer.total_paid+amount)
            
            created_by = form.save(commit=False)
            created_by.created_by = request.user
            created_by.save()
            messages.success(request, 'Credit sale payment successful')
            
            return redirect(reverse('creditSalePayment'))
        messages.error(request, form.errors.as_text())
        return redirect(reverse('creditSalePayment'))
            
        
    context = {
        'form': form,
        'customers':customers,
        'credit_sales':credit_sales,
        'credit_sale_payments':credit_sale_payments,
        'company_locations': company_locations,
        'banks':banks,
        'payment_modes':payment_modes,
        'users':users,
    }
    return render(request, 'dashboard/transaction_payment/creditpayment.html', context)






# Stock Purchase Payment
def stockPurchasePayment(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.stock_purchase_payment or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
        
    form = stockPurchasePaymentForm()
    suppliers = Supplier.objects.all()
    credit_sales = Sales.objects.filter(sale_type='credit')
    #print(suppliers)
    if request.method == 'POST':
        form = stockPurchasePaymentForm(request.POST)
        if form.is_valid():
            amount = form.cleaned_data.get('amount')
            supplier = form.cleaned_data.get('supplier')
            amount = Decimal(amount)
            Supplier.objects.filter(id=supplier.id).update(debit= supplier.debit+amount)
            
            form.save()
            messages.success(request, 'Stock Purchase payment successful')
            return redirect(reverse('stockPurchasePayment'))
        messages.error(request, form.errors.as_text())
        return redirect(reverse('stockPurchasePayment'))  
        
    context = {
        'form': form,
        'suppliers':suppliers,
        'credit_sales':credit_sales,
    }
    return render(request, 'dashboard/transaction_payment/stockPurchasePayment.html', context)







def expense(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.expense or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = ExpenseForm()
    
    expenses = Expenses.objects.all()
    bank_accounts = BankAccounts.objects.all()
    payment_modes = PaymentMode.objects.all()
    expense_types = ExpenseType.objects.all()
    companylocations = CompanyLocation.objects.all()

    if request.method == 'POST':
        form = ExpenseForm(request.POST)
        if form.is_valid():
            created_by = form.save(commit=False)
            created_by.created_by = request.user
            created_by.save()
            messages.success(request, 'Expense added successfully')
            return redirect(reverse('expense'))
            
        
    context = {
        'form': form,
        'expenses': expenses,
        'bank_accounts': bank_accounts,
        'payment_modes': payment_modes,
        'expense_types': expense_types,
        'companylocations': companylocations,
    }
    
    
    return render(request, 'dashboard/transaction/expenses.html', context)




def bankTransaction(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.bank_transaction or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    form = BankTransactionForm()
    bank_transactions = BankTransaction.objects.all()
    bank_accounts = BankAccounts.objects.all()
    payment_modes = PaymentMode.objects.all()
    expense_types = ExpenseType.objects.all()
    companylocations = CompanyLocation.objects.all()

    if request.method == 'POST':
        form = BankTransactionForm(request.POST)
        if form.is_valid():
            created_by = form.save(commit=False)
            created_by.created_by = request.user
            created_by.save()
            messages.success(request, 'Bank transaction added successfully')
            return redirect(reverse('bankTransaction'))
            
        
    context = {
        'form': form,
        'bank_transactions': bank_transactions,
        'bank_accounts': bank_accounts,
        'payment_modes': payment_modes,
        'expense_types': expense_types,
        'companylocations': companylocations,
    }
    
    
    return render(request, 'dashboard/transaction/bank_transaction.html', context)





# delete  views
def deleteCompanyLocation(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    companylocation = CompanyLocation.objects.filter(id=request.POST.get('id'))
    
    #print(companylocation)
    if companylocation:   
        try:
            companylocation.delete()
        except:
            messages.error(request, "Company location is in use")
        messages.success(request, "Company location deleted successfully")
    else:
        messages.error(request, "Company location does not exist")
    
    return redirect(reverse("companylocation"))



def deleteCompanyProfile(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    companyprofile = CompanyProfile.objects.filter(id=request.POST.get('id'))
    
    #print(companyprofile)
    if companyprofile:  
        try: 
            companyprofile.delete()
        except:
            messages.error(request, "Company profile is in use")
        messages.success(request, "Company location deleted successfully")
    else:
        messages.error(request, "Company location does not exist")
    
    return redirect(reverse("companyprofile"))



def deleteProductCategory(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    productcategory = ProductCategory.objects.filter(id=request.POST.get('id'))
    
    #print(productcategory)
    if productcategory: 
        try:  
            productcategory.delete()
        except:
            messages.error(request, "Product category is in use")
        messages.success(request, "Product category deleted successfully")
    else:
        messages.error(request, "Product category does not exist")
    
    return redirect(reverse("productcategory"))




def deleteProducts(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    product = Products.objects.filter(id=request.POST.get('id'))
    
    #print(product)
    if product:  
        try: 
            product.delete()
        except:
            messages.error(request, "Product is in use")
        messages.success(request, "Product deleted successfully")
    else:
        messages.error(request, "Product does not exist")
    
    return redirect(reverse("products"))




def deleteProductPrice(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    productprice = ProductPrice.objects.filter(id=request.POST.get('id'))
    
    #print(productprice)
    if productprice: 
        try: 
            productprice.delete()
        except:
            messages.error(request, "Product price cannot be deleted")
        messages.success(request, "Product price deleted successfully")
    else:
        messages.error(request, "Product price does not exist")
    
    return redirect(reverse("productprice"))




def deleteCustomers(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    customer = Customer.objects.filter(id=request.POST.get('id'))
    
    #print(customer)
    if customer:
        try: 
            customer.delete()
            messages.success(request, "Customer deleted successfully")
        except:
            messages.error(request, "Customer cannot be deleted")
    else:
        messages.error(request, "Customer does not exist")
    
    return redirect(reverse("customers"))





def deleteSuppliers(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    supplier = Supplier.objects.filter(id=request.POST.get('id'))
    
    #print(supplier)
    if supplier: 
        try:  
            supplier.delete()
        except:
            messages.error(request, "Supplier cannot be deleted")
        messages.success(request, "Supplier deleted successfully")
    else:
        messages.error(request, "Supplier does not exist")
    
    return redirect(reverse("suppliers"))






def deleteBankAccounts(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    bankaccount = BankAccounts.objects.filter(id=request.POST.get('id'))
    
    #print(bankaccount)
    if bankaccount:   
        try:
            bankaccount.delete()
        except:
            messages.error(request, "Bank Account is in use")
        messages.success(request, "Bank account deleted successfully")
    else:
        messages.error(request, "Bank account does not exist")
    
    return redirect(reverse("bankaccounts"))






def deleteBank(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    bank = Bank.objects.filter(id=request.POST.get('id'))
    
    #print(bank)
    if bank:
        try:   
            bank.delete()
        except:
            messages.error(request, "Bank Account is in use")
        messages.success(request, "Bank deleted successfully")
    else:
        messages.error(request, "Bank does not exist")
    
    return redirect(reverse("bank"))






def deletePackage(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    package = Package.objects.filter(id=request.POST.get('id'))
    
    #print(package)
    if package:   
        try:
            package.delete()
        except:
            messages.error(request, "Package is not in use")
        messages.success(request, "Package deleted successfully")
    else:
        messages.error(request, "Package does not exist")
    
    return redirect(reverse("package"))



def deleteColor(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    color = Colors.objects.filter(id=request.POST.get('id'))
    
    #print(color)
    if color:   
        try:
            color.delete()
        except:
            messages.error(request, "Color is in use")
        messages.success(request, "Color deleted successfully")
    else:
        messages.error(request, "Color does not exist")
    
    return redirect(reverse("colors"))






def deleteExpenseType(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    expensetype = ExpenseType.objects.filter(id=request.POST.get('id'))
    
    #print(expensetype)
    if expensetype: 
        try:  
            expensetype.delete()
        except:
            messages.error(request, "Expense Type is in use")
        messages.success(request, "Expense type deleted successfully")
    else:
        messages.error(request, "Expense type does not exist")
    
    return redirect(reverse("expensetype"))





def deletePaymetMode(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    paymentmode = PaymentMode.objects.filter(id=request.POST.get('id'))
    
    #print(paymentmode)
    if paymentmode: 
        try:  
            paymentmode.delete()
        except:
            messages.error(request, "Payment Mode is in use")
        messages.success(request, "Payment mode deleted successfully")
    else:
        messages.error(request, "Payment mode does not exist")
    
    return redirect(reverse("paymentmode"))







def deletePaymentMode(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    paymentmode = PaymentMode.objects.filter(id=request.POST.get('id'))
    
    #print(paymentmode)
    if paymentmode: 
        try:  
            paymentmode.delete()
        except:
            messages.error(request, "Payment Mode is in use")
        messages.success(request, "Payment mode deleted successfully")
    else:
        messages.error(request, "Payment mode does not exist")
    
    return redirect(reverse("paymentmode"))







def deleteTransactionType(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    transactiontype = BankTransactionType.objects.filter(id=request.POST.get('id'))
    
    #print(transactiontype)
    if transactiontype:   
        try:
            transactiontype.delete()
        except:
            messages.error(request, "Transaction Type is in use")
        messages.success(request, "Transaction type deleted successfully")
    else:
        messages.error(request, "Transaction type does not exist")
    
    return redirect(reverse("transactiontype"))







def deleteExpense(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    #print(request.POST.get('id'))
    expense = Expenses.objects.filter(id=request.POST.get('id'))
    
    #print(expense)
    if expense:   
        try:
            expense.delete()
        except:
            messages.error(request, "Expense Type is in use")
        messages.success(request, "Expense deleted successfully")
    else:
        messages.error(request, "Expense does not exist")
    
    return redirect(reverse("expense"))






def deleteCreditSalePayment(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    
    payment = CreditSalePayment.objects.filter(id=request.POST.get('id')).last()
    
    customer = payment.customer
    
    if payment:   
        try:
            payment.delete() 
        except:
            messages.error(request, "Payment not delete")
            
        customer_payments = CreditSalePayment.objects.filter(customer=customer.id)
        new_payment_upadate = Customer.objects.get(id=customer.id)
        
        payments = 0
        for i in customer_payments:
            payments+=i.amount
        
        new_payment_upadate.total_paid = payments     
        new_payment_upadate.save()
        
        messages.success(request, "Payment deleted successfully")
    else:
        messages.error(request, "Payment does not exist")
    
    return redirect(reverse("creditSalePayment"))





def deletePaletCoding(request):
    if request.method != "POST":
        messages.error(request, "Access Denied")
    
    palet = BatchPaleting.objects.filter(id=request.POST.get('id')).last()
    
    if palet:   
        try:
            palet.delete() 
        except:
            messages.error(request, "Palet not delete")

        messages.success(request, "Palet deleted successfully")
    else:
        messages.error(request, "Palet does not exist")
    
    return redirect(reverse("PaletCoding"))




# Edit / Update views
def updateCompanyProfile(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        profile_id = request.POST.get('id')
        #print(profile_id)
        profile = CompanyProfile.objects.filter(id=profile_id).last()
        #print(profile)
        form = CompanyProfileForm(request.POST or None, instance=profile)
        
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Company Profile Updated Successfully")
        else:
            messages.error(request, "Company Profile Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")

    return redirect(reverse('companyprofile'))







def updateCompanyLocation(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        location_id = request.POST.get('id')
        #print(location_id)
        location = CompanyLocation.objects.filter(id=location_id).last()
        #print(location)
        form = CompanyLocationForm(request.POST or None, instance=location)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Company Location Updated")
        else:
            messages.error(request, "Form has errors")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('companylocation'))







def updateProductCategory(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        category_id = request.POST.get('id')
        #print(category_id)
        category = ProductCategory.objects.filter(id=category_id).last()
        #print(category.description)
        form = ProductCategoryForm(request.POST or None, instance=category)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Product Category Updated Successfully")
        else:
            messages.error(request, "Product Category Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('productcategory'))







def updateProducts(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        product_id = request.POST.get('id')
        #print(product_id)
        product = Products.objects.filter(id=product_id).last()
        #print(product.description)
        form = ProductsForm(request.POST or None, instance=product)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Product Updated Successfully")
        else:
            messages.error(request, "Product Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('products'))




def updatePaletCoding(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        palet_id = request.POST.get('id')
        
        palet = BatchPaleting.objects.filter(id=palet_id).last()
        
        form = PaletForm(request.POST or None, instance=palet)
        #print(form)
        #print(form)
        if form.is_valid():
            editeb_by = form.save(commit=False)        
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Palet coding Updated Successfully")
        else:
            messages.error(request, "Palet coding Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('PaletCoding'))







def updateProductPrice(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        productprice_id = request.POST.get('id')

        #print(productprice_id)
        productprice = ProductPrice.objects.filter(id=productprice_id).last()
        current_stock = productprice.stockLevel
        form = ProductPriceForm(request.POST or None, instance=productprice)
        
        if form.is_valid():
            updated_stock = request.POST.get("stockLevel")
            
            updated_stock = int(updated_stock)
            
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            
            #print(current_stock==updated_stock)
            if current_stock == updated_stock:
                pass
            else:
                inwards = updated_stock - current_stock
                stock = Stock(description="Stock Variance", invoicce_number="SV", inward=inwards, productprice=productprice, balance=updated_stock, created_by=request.user )
                
                user_activity = UserActivitiesReport(user=request.user, activity=f'Stock Variance of {productprice.product} from {current_stock} to {updated_stock}')
                stock.save()
                user_activity.save()
            editeb_by.save()
            
            messages.success(request, "Product Price Updated Successfully")
        else:
            messages.error(request, "Product Price Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('productprice'))







def updateCustomers(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        customer_id = request.POST.get('id')
        #print(customer_id)
        customer = Customer.objects.filter(id=customer_id).last()
        #print(customer.name)
        form = CustomersForm(request.POST or None, instance=customer)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            # debit = form.cleaned_data.get('debit')
            # credit = form.cleaned_data.get('credit')
            # opening_balance =  credit - debit
            editeb_by.save()
            
            messages.success(request, "Customer Updated Successfully")
        else:
            #print(form.errors.as_text())
            messages.error(request, "Customer Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('customers'))







def updateSuppliers(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        supplier_id = request.POST.get('id')
        #print(supplier_id)
        supplier = Supplier.objects.filter(id=supplier_id).last()
        #print(supplier.name)
        form = SupplierForm(request.POST or None, instance=supplier)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Supplier Updated Successfully")
        else:
            messages.error(request, "Supplier Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('suppliers'))







def updateBankAccounts(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        bankaccount_id = request.POST.get('id')
        if bankaccount_id:
            BankAccounts.objects.filter(id=bankaccount_id).update(edited_by=request.user, account_number=request.POST.get('account_number'), account_name=request.POST.get('account_name'), bank=request.POST.get('bank'), account_type=request.POST.get('account_type'), current_balance=request.POST.get('current_balance'), bank_branch=request.POST.get('bank_branch'))
            messages.success(request, "Bank Account Updated Successfully")
        else:
            messages.error(request, "Bank Account Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('bankaccounts'))






def updateBank(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        banktransaction_id = request.POST.get('id')
        #print(banktransaction_id)
        banktransaction = Bank.objects.filter(id=banktransaction_id).last()
        #print(banktransaction.description)
        form = BankForm(request.POST or None, instance=banktransaction)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Bank Transaction Updated Successfully")
        else:
            messages.error(request, "Bank Transaction Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('bank'))






def updatePackage(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        package_id = request.POST.get('id')
        #print(package_id)
        package = Package.objects.filter(id=package_id).last()
        #print(package.name)
        form = PackageForm(request.POST or None, instance=package)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Package Updated Successfully")
        else:
            messages.error(request, "Package Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('package'))




def updateColors(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        color_id = request.POST.get('id')
        #print(color_id)
        color = Colors.objects.filter(id=color_id).last()
        #print(color)
        form = ColorsForm(request.POST or None, instance=color)
        #print(form.is_valid())
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Color Updated Successfully")
        else:
            messages.error(request, "Color Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('colors'))







def updateExpenseType(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        expensetype_id = request.POST.get('id')
        #print(expensetype_id)
        expensetype = ExpenseType.objects.filter(id=expensetype_id).last()
        #print(expensetype.name)
        form = ExpenseTypeForm(request.POST or None, instance=expensetype)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Expense Type Updated Successfully")
        else:
            messages.error(request, "Expense Type Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('expensetype'))







def updatePaymentMode(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        paymentmode_id = request.POST.get('id')
        #print(paymentmode_id)
        paymentmode = PaymentMode.objects.filter(id=paymentmode_id).last()
        #print(paymentmode.name)
        form = PaymentModeForm(request.POST or None, instance=paymentmode)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Payment Mode Updated Successfully")
        else:
            messages.error(request, "Payment Mode Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('paymentmode'))







def updateTransactionType(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        transactiontype_id = request.POST.get('id')
        #print(transactiontype_id)
        transactiontype = BankTransactionType.objects.filter(id=transactiontype_id).last()
        #print(transactiontype.name)
        form = TransactionTypeForm(request.POST or None, instance=transactiontype)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Transaction Type Updated Successfully")
        else:
            messages.error(request, "Transaction Type Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('transactiontype'))







def updateStockLevel(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        stocklevel_id = request.POST.get('id')

        stock_level = request.POST.get('stockLevel')
        
        if stock_level and stocklevel_id:
            #ProductPrice.objects.filter(id=stocklevel_id).update(stockLevel=stock_level)
            #print(stocklevel_id)
            
            messages.success(request, "Stock Level Updated Successfully")
        else:
            messages.error(request, "Stock Level Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('stocklevel'))







def updateExpense(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
    try:
        expense_id = request.POST.get('id')
        #print(expense_id)
        expense = Expenses.objects.filter(id=expense_id)[0] 
        #print(expense.name)
        form = ExpenseForm(request.POST or None, instance=expense)
        if form.is_valid():
            editeb_by = form.save(commit=False)
            editeb_by.edited_by = request.user
            #print(editeb_by.edited_by)
            editeb_by.save()
            
            messages.success(request, "Expense Updated Successfully")
        else:
            messages.error(request, "Expense Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('expense'))





def updateCreditSalePayment(request):
    if request.method != 'POST':
        messages.error(request, "Access Denied")
        return redirect(reverse('creditSalePayment'))
    
    try:
        payment_id = request.POST.get('id')
        customer = request.POST.get('customer')
        payment = CreditSalePayment.objects.filter(id=payment_id).last()

        form = CreditSalePaymentForm(request.POST or None, instance=payment)

            
        if form.is_valid():
            amount = form.cleaned_data.get('amount')
            customer = form.cleaned_data.get('customer')
            amount = Decimal(amount)
            #print(customer.total_paid) 
            
            edited_by = form.save(commit=False)
            edited_by.edited_by = request.user
            edited_by.save()
            
            customer_payments = CreditSalePayment.objects.filter(customer=customer.id)
            new_payment_upadate = Customer.objects.get(id=customer.id)
            
            payments = 0
            for i in customer_payments:
                payments+=i.amount
            
            new_payment_upadate.total_paid = payments     
            new_payment_upadate.save()       
                        
            messages.success(request, "Payment Updated Successfully")
        else:
            messages.error(request, "Payment Not Updated")
    except:
        messages.error(request, "Access To This Resource Denied")
    
    return redirect(reverse('creditSalePayment'))





# request views
def viewCompanyLocationById(request):
    id = request.GET.get('id', None)
    company = CompanyLocation.objects.filter(id=id)
    context = {}
    
    if not company.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        company = company[0]
        context["name"] = company.name
        context["phone"] = company.phone
        context["id"] = company.id
        #print(context)

    return JsonResponse(context)






def viewCompanyProfileById(request):
    id = request.GET.get('id', None)
    company = CompanyProfile.objects.filter(id=id)
    context = {}
    
    if not company.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        company = company[0]
        context["name"] = company.name
        context["phone"] = company.phone
        context["email"] = company.email
        context["id"] = company.id
        context["address"] = company.address
        context["website"] = company.website
        context["vatNo"] = company.vatNo
        context["vatRate"] = company.vatRate
        context["NHIL_Rate"] = company.NHIL_Rate
        context["A4_Printer"] = company.A4_Printer
        context["no_of_receipts"] = company.no_of_receipts
        context["show_vat"] = company.show_vat
        context["firstTextBelowReceipt"] = company.firstTextBelowReceipt
        context["secondTextBelowReceipt"] = company.secondTextBelowReceipt
        #print(context)
        
        return JsonResponse(context)
        





def viewProductCategoryById(request):
    id = request.GET.get('id', None)
    category = ProductCategory.objects.filter(id=id)
    context = {}
    
    if not category.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        category = category[0]
        context["id"] = category.id
        context["name"] = category.name
        context["description"] = category.description
        
        #print(context)
        return JsonResponse(context)
        
        
        
 
        
        
def viewProductsById(request):
    id = request.GET.get('id', None)
    products = Products.objects.filter(id=id)
    context = {}
    
    if not products.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        products = products[0]
        context["id"] = products.id
        context["name"] = products.name
        if products.baseUnit:
            context["baseUnit"] = products.baseUnit.id
        if products.category:
            context["category"] = products.category.id
        context["reorderLevel"] = products.reorderLevel
        context["is_active"] = products.is_active
    #print(context['reorderLevel'])
    return JsonResponse(context)





def viewPaletsById(request):
    id = request.GET.get('id', None)
    palet = BatchPaleting.objects.filter(id=id)
    context = {}
    
    if not palet.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        palet = palet[0]
        context["id"] = palet.id
        context["batch_number"] = palet.batch_number
        if palet.product:
            context["product"] = palet.product.id
        if palet.color:
            context["color"] = palet.color.id
        context["active"] = palet.active
    # print(context)
    return JsonResponse(context)





 
# deleteProductPrice
# updateProductPrice

def viewProductPriceById(request):
    id = request.GET.get('id', None)
    
    #print(id)
    productprice = ProductPrice.objects.filter(id=id)

    #print(productprice)
    context = {}
    if not productprice.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        productprice = productprice[0]
        context["id"] = productprice.id
        if productprice.product:
            context["product"] = productprice.product.name
            context["product_id"] = productprice.product.id
        if productprice.package:
            context["package"] = productprice.package.name
            context["package_id"] = productprice.package.id
        context["cost_price"] = productprice.cost_price
        context["selling_price"] = productprice.selling_price
        context["qty_in_package"] = productprice.qty_in_package
        context["stockLevel"] = productprice.stockLevel
        context["VAT"] = productprice.VAT
        context["NHIL"] = productprice.NHIL
        context["margin"] = productprice.margin
        if productprice.companylocation:
            context["companylocation"] = productprice.companylocation.name
            context["companylocation"] = productprice.companylocation.id
        context["sale_type"] = productprice.sale_type
        
        
        
    return JsonResponse(context)
        




def getProductToUpdatePrices(request):
    id = request.GET.get('id', None)
    productprice = SalesItem.objects.filter(id=id)

    context = {}
    if not productprice.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        productprice = productprice[0]
        context["id"] = productprice.id
        if productprice.product:
            context["product"] = productprice.product
            context["product_id"] = productprice.product.id
        if productprice.package:
            context["package"] = productprice.name
            context["package_id"] = productprice.package.id
        context["cost_price"] = productprice.cost_price
        context["selling_price"] = productprice.selling_price
        context["qty_in_package"] = productprice.qty_in_package
        context["stockLevel"] = productprice.stockLevel
        

    return JsonResponse(context)





def viewCustomersById(request):
    id = request.GET.get('id', None)
    customer = Customer.objects.filter(id=id)
    context = {}
    
    if not customer.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        customer = customer[0]
        context["id"] = customer.id
        context["name"] = customer.name
        context["phone"] = customer.phone
        context["email"] = customer.email
        context["address"] = customer.address
        context["credit"] = customer.credit
        context["creditLimit"] = customer.creditLimit
        context["debit"] = customer.debit
        context["registration_date"] = date(customer.registration_date, "Y-m-d")
        context["is_active"] = customer.is_active
        
        #print(context)

    return JsonResponse(context)






def viewSuppliersById(request):
    id = request.GET.get('id', None)
    customer = Supplier.objects.filter(id=id)
    context = {}
    
    if not customer.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        customer = customer[0]
        context["id"] = customer.id
        context["name"] = customer.name
        context["phone"] = customer.phone
        context["email"] = customer.email
        context["address"] = customer.address
        context["credit"] = customer.credit
        context["debit"] = customer.debit
        context["is_active"] = customer.is_active
        
        #print(context)

    return JsonResponse(context)






def viewBankAccountsById(request):
    id = request.GET.get('id', None)
    bank = BankAccounts.objects.filter(id=id)
    context = {}
    
    if not bank.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        bank = bank[0]
        context["id"] = bank.id
        context["account_number"] = bank.account_number
        context["account_name"] = bank.account_name
        context["account_type"] = bank.account_type
        context["bank_branch"] = bank.bank_branch
        context["current_balance"] = bank.current_balance
        if bank.bank:
            context["bank"] = bank.bank.name
            context["bank_id"] = bank.bank.id
        
        #print(context)
    return JsonResponse(context) 





def viewBankById(request):
    id = request.GET.get('id', None)
    bank = Bank.objects.filter(id=id)
    context = {}
    
    if not bank.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        bank = bank[0]
        context["id"] = bank.id
        context["name"] = bank.name
        
        #print(context)
    return JsonResponse(context)





def viewPackageById(request):
    id = request.GET.get('id', None)
    package = Package.objects.filter(id=id)
    context = {}
    
    if not package.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        package = package[0]
        context["id"] = package.id
        context["name"] = package.name

        
        #print(context)
    return JsonResponse(context)





def viewColorById(request):
    id = request.GET.get('id', None)
    color = Colors.objects.filter(id=id)
    context = {}
    
    if not color.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        color = color[0]
        context["id"] = color.id
        context["color"] = color.color

        
        #print(context)
    return JsonResponse(context)





def viewExpenseTypeById(request):
    id = request.GET.get('id', None)
    expenseType = ExpenseType.objects.filter(id=id)
    context = {}
    
    if not expenseType.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        expenseType = expenseType[0]
        context["id"] = expenseType.id
        context["name"] = expenseType.name

        
        #print(context)
    return JsonResponse(context)





def viewPaymentModeById(request):
    id = request.GET.get('id', None)
    paymentMode = PaymentMode.objects.filter(id=id)
    context = {}
    
    if not paymentMode.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        paymentMode = paymentMode[0]
        context["id"] = paymentMode.id
        context["name"] = paymentMode.name

        
        #print(context)
    return JsonResponse(context)





def viewTransactionTypeById(request):
    id = request.GET.get('id', None)
    transactionType = BankTransactionType.objects.filter(id=id)
    context = {}
    
    if not transactionType.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        transactionType = transactionType[0]
        context["id"] = transactionType.id
        context["name"] = transactionType.name

        
        #print(context)
    return JsonResponse(context)





def viewStockLevelById(request):
    id = request.GET.get('id', None)
    stock = ProductPrice.objects.filter(id=id)
    context = {}
    
    if not stock.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        stock = stock[0]
        context["id"] = stock.id
        if stock.package:
            context["package"] = stock.package.name
        if stock.product:
            context["product"] = stock.product.name
        context["stockLevel"] = stock.stockLevel

        
        #print(context)
    return JsonResponse(context)





def viewExpenseById(request):
    id = request.GET.get('id', None)
    expense = Expenses.objects.filter(id=id)
    context = {}
    
    if not expense.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        expense = expense[0]
        context["id"] = expense.id
        if expense.expense_type:
            context["expense_type"] = expense.expense_type.id
        if expense.payment_mode:
            context["payment_mode"] = expense.payment_mode.id
        if expense.bank_account:
            context["bank_account"] = expense.bank_account.id
        if expense.companylocation:
            context["companylocation"] = expense.companylocation.id
        context["amount"] = expense.amount
        context["expense_date"] = date(expense.expense_date, "Y-m-d")
        context["description"] = expense.description
        context["cheque_number"] = expense.cheque_number
        context["cheque_date"] = date(expense.cheque_date, "Y-m-d")
        
        #print(context)


    return JsonResponse(context)






def viewCommentStatusById(request):
    id = request.GET.get('id', None)
    #print(id)
    sales_approval = CreditSaleApproval.objects.filter(id=id)
    context = {}
    
    #print(sales_approval)
    if not sales_approval.exists():
        
        context["code"] = 404
    else:
        context["code"] = 200
        sales_approval = sales_approval[0]
        context["id"] = sales_approval.id
        if sales_approval.comments:
            context["comments"] = sales_approval.comments.id
        context["status"] = sales_approval.status
        #print(context)
        
    return JsonResponse(context)




# view customer payment
def viewCustomerPaymentAtAccountReport(request):
    id = request.GET.get('id', None)
    customer_payments = CreditSalePayment.objects.filter(customer=id)

    queryset = customer_payments.values('amount', 'payment_date__date', 'customer__name', 'company_location__name', 'amount', 'paid_by', 'payment_mode__name', 'created_by__username')
    #print(queryset)
    return JsonResponse(list(queryset), safe=False)





def viewCreditSalePaymentById(request):
    
    id = request.GET.get('id', None)
    payment = CreditSalePayment.objects.filter(id=id)
    context = {}
    
    if not payment.exists():
        context["code"] = 404
    else:
        context["code"] = 200
        payment = payment[0]
        context["id"] = payment.id
        if payment.customer:
            context["customer"] = payment.customer.id
        if payment.payment_mode:
            context["payment_mode"] = payment.payment_mode.id
        if payment.bank:
            context["bank"] = payment.bank.id
        if payment.company_location:
            context["company_location"] = payment.company_location.id
        if payment.paid_by:
            context['paid_by'] = payment.paid_by
        context["amount"] = payment.amount
        context["payment_date"] = date(payment.payment_date, "Y-m-d")
        context["cheque_number"] = payment.cheque_number
        context["cheque_date"] = date(payment.cheque_date, "Y-m-d")
        context["bank_branch"] = date(payment.bank_branch)
      
    return JsonResponse(context)




# report views
# Sales Report
def salesReport(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.sale_report or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    
    sales = Sales.objects.filter(sales_date__date=timezone.now().date())
    companylocations = CompanyLocation.objects.all()
    users = Acount_User.objects.all()
    #print(request.method)
    if request.method == "POST":
        #print('i HAVE BEEN CALLED rather than the other one 2')
        todaySales = Sales.objects.filter(sales_date__date=timezone.now().date())
        context = {}
        data = []
        for sale in todaySales:
            context["id"] = sale.id
            context["sales_id"] = sale.sales_id
            context["customer"] = sale.customer
            context["sales_date"] = sale.sales_date
            context["total_amount"] = sale.total_amount
            context["total_discount"] = sale.total_discount
            context["net_amount"] = sale.net_amount
            context["paid_amount"] = sale.paid_amount
            context["balance"] = sale.balance
            context["cash"] = sale.cash
            context["momo"] = sale.momo
            context["visa"] = sale.visa
            context["cashier"] = sale.created_by.username
            context["companyLocation"] = sale.created_by.companyLocation
            
            data.append(context)
        #print(data)
        #print('i HAVE BEEN CALLED')
        return JsonResponse(data, safe=False)
        
    
    
    context = {'sales': sales, 'users': users, 'companylocations': companylocations}
    return render(request, 'dashboard/reports/sales_report.html', context)








def saleAndProductReport(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.sale_report or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    
    companylocations = CompanyLocation.objects.all()
    users = Acount_User.objects.all()
    #print(request.method)
    # if request.method == "POST":
    #     #print('i HAVE BEEN CALLED rather than the other one 2')
    #     todaySales = Sales.objects.filter(sales_date__date=timezone.now().date())
    #     context = {}
    #     data = []
    #     for sale in todaySales:
    #         sales_items = SalesItem.objects.filter(sales=sale.sales_id)
    #         context["id"] = sale.id
    #         context["sales_id"] = sale.sales_id
    #         context["customer"] = sale.customer
    #         context["sales_date"] = sale.sales_date
    #         context["total_amount"] = sale.total_amount
    #         context["total_discount"] = sale.total_discount
    #         context["net_amount"] = sale.net_amount
    #         context["paid_amount"] = sale.paid_amount
    #         context["balance"] = sale.balance
    #         context["cash"] = sale.cash
    #         context["momo"] = sale.momo
    #         context["cashier"] = sale.created_by.username
            
    #         data.append(context)
    #     #print(data)
    #     #print('i HAVE BEEN CALLED')
    #     return JsonResponse(data, safe=False)
        
    context = {'users': users, 'companylocations': companylocations}
    return render(request, 'dashboard/reports/sale_and_product_report.html', context)









def stockApprovalsReport(request):
    
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.can_approve_stock or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    
    sales = Sales.objects.filter(stock_approval_date__date=timezone.now().date(), status=True)
    companylocations = CompanyLocation.objects.all()
    users = Acount_User.objects.all()
    
    
    todays_stock = {}
    stock_approvals = Stock.objects.filter(trans_date__date=timezone.now().date())
    
    for stock_approval in stock_approvals:
        if stock_approval.productprice in todays_stock:
            todays_stock[stock_approval.productprice] += stock_approval.outward
        else:
            todays_stock[stock_approval.productprice] = stock_approval.outward
            
    #print(request.method)
    if request.method == "POST":
        
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("stockApprovalsReport"))
            
            
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        companylocation = json_data['companylocation']
        sale_type = json_data['sale_type']
        user = json_data['user']
        
        sales = Sales.objects.all()
            
        if from_date != "" and not None:
            sales = sales.filter(sales_date__date__gte=from_date)
        else: 
            sales = sales.filter(sales_date__date=timezone.now().date())
        
        if to_date != "" and not None:
            sales = sales.filter(sales_date__date__lte=to_date)
            
        if companylocation != "" and not None:
            sales = sales.filter(company_location=companylocation)
            
        if sale_type != "" and not None:
            sales = sales.filter(sale_type=sale_type)
            
        if user != "" and not None:
            sales = sales.filter(status_approved_by=user)
            
            
        stock_approvals = {}
        if sales:
            for sale in sales:
                salesitems = sale.salesitem_set.all()
                #print(salesitems)
                for item in salesitems:
                    if str(str(item.productprice_id) + str(item.product)) in stock_approvals:
                        stock_approvals[str(str(item.productprice_id) + str(item.product))] += int(item.qty)
                    else:
                        stock_approvals[str(str(item.productprice_id) + str(item.product))] = int(item.qty)
        else:
            stock_approvals = {}
        
        #print(stock_approvals)
        return JsonResponse(stock_approvals, safe=False)

    context = {'sales': sales, 'users': users, 'companylocations': companylocations, 'todays_stock':todays_stock}
    return render(request, 'dashboard/reports/stock_approval_report.html', context)







# Sales Summary Report
def SalesSummaryReport(request):
    sales = Sales.objects.filter(sales_date__date=timezone.now().date())
    companylocations = CompanyLocation.objects.all()
    context = {'sales': sales, 'companylocations': companylocations}
    credit_repayments = CreditSalePayment.objects.filter(payment_date__date=timezone.now().date())
    prices = ProductPrice.objects.all()
    
    momo_sale = 0
    momo_payments = 0
    stock_value = 0
    net_total = 0
    total_discount = 0
    grand_total = 0
    total_credit = 0
    credit_discount = 0
    total_cash_sale = 0
    cash_discount = 0
    wholesale_total = 0
    wholesale_discount = 0
    crdit_repayment_amount = 0
    credit_paid_amount = 0

    cash_segments = {
    'cedi1': 0,
    'cedi2': 0,
    'cedi5': 0,
    'cedi10': 0,
    'cedi20': 0,
    'cedi50': 0,
    'cedi100': 0,
    'cedi200': 0,
    'gp10': 0,
    'gp20': 0,
    'gp50': 0
    }
    
    for credit_repayment in credit_repayments:
        crdit_repayment_amount+=credit_repayment.amount
        print(credit_repayment.payment_mode.name)
        if  credit_repayment.payment_mode.name.upper == "MOMO" or 'MOBILE MONEY':
            print("Momo here")
            momo_payments += credit_repayment.amount
    
    for price in prices:
         stock_value += price.stockLevel * price.selling_price
      
    for sale in sales:  
        net_total += sale.net_amount
        total_discount += sale.total_discount
        grand_total += sale.total_amount
        momo_sale += sale.momo
        
        if sale.sale_type == "Cash Sale":
            total_cash_sale += sale.net_amount
            cash_discount += sale.total_discount
        if sale.sale_type == "Credit Sale":
            total_credit += sale.net_amount 
            credit_discount += sale.total_discount
            credit_paid_amount += sale.paid_amount
        if sale.sale_type == "wholesale":
            wholesale_total += sale.net_amount
            wholesale_discount +=sale.total_discount
            

    for sale in sales:
        cash_segments['cedi1'] += int(sale.cedi1)
        cash_segments['cedi2'] += int(sale.cedi2)
        cash_segments['cedi5'] += int(sale.cedi5)
        cash_segments['cedi10'] += int(sale.cedi10)
        cash_segments['cedi20'] += int(sale.cedi20)
        cash_segments['cedi50'] += int(sale.cedi50)
        cash_segments['cedi100'] += int(sale.cedi100)
        cash_segments['cedi200'] =+ int(sale.cedi200)
        cash_segments['gp10'] += int(sale.gp10)
        cash_segments['gp20'] += int(sale.gp20)
        cash_segments['gp50'] += int(sale.gp50)
        

    context['stock_value'] = stock_value 
    context['net_total'] = net_total
    context['total_discount'] = total_discount
    context['grand_total'] = grand_total
    
    context['total_credit'] = total_credit 
    context['credit_discount'] = credit_discount
    context['total_cash_sale'] = total_cash_sale
    context['cash_discount'] = cash_discount
    context['wholesale_total'] = wholesale_total
    context['wholesale_discount'] = wholesale_discount
    context['overal'] = crdit_repayment_amount + net_total
    
    context['crdit_repayment_amount'] = crdit_repayment_amount
    
    context['momo_sale'] = momo_sale
    context['momo_payments'] = momo_payments
    context['cash_segments']= cash_segments
    
    context['cedi1'] = float(cash_segments['cedi1']   * 1)
    context['cedi2'] =     float(cash_segments['cedi2'] * 2)
    context['cedi5'] =     float(cash_segments['cedi5'] * 5)
    context['cedi10'] =     float(cash_segments['cedi10'] * 10)
    context['cedi20'] =     float(cash_segments['cedi20'] * 20)
    context['cedi50'] =     float(cash_segments['cedi50']  *  50)
    context['cedi100'] =     float(cash_segments['cedi100'] * 100)
    context['cedi200'] =     float(cash_segments['cedi200'] * 200)
    context['gp10'] =     (cash_segments['gp10'] * 0.1)
    context['gp20'] =     (cash_segments['gp20'] * 0.2)
    context['gp50'] =     (cash_segments['gp50'] * 0.5)
    print(context)
    return render(request, 'dashboard/reports/sales_summary_report.html', context)





# Stock Control Report
def stockControlReport(request):
    products = ProductPrice.objects.all()
    companylocations = CompanyLocation.objects.all()
    context = {'products': products, 'companylocations': companylocations, }
    return render(request, 'dashboard/reports/stock_control_report.html', context)





def stockRequisitionReport(request):

    return render(request, 'dashboard/reports/stock_requisition_report.html')





# Product Sale Report
def ProductSaleReport(request):
    products = ProductPrice.objects.all()
    companylocations = CompanyLocation.objects.all()
    context = {'products': products, 'companylocations':companylocations}
    return render(request, 'dashboard/reports/product_sale_report.html', context)





# Stock Control Summary Report
def stockControlSummaryReport(request):
    products = ProductPrice.objects.all()
    companylocations = CompanyLocation.objects.all()
    context = {'products': products, 'companylocations': companylocations, }
    return render(request, 'dashboard/reports/stock_control_summary.html', context)





# Stock Control Report
def stockValueReport(request):
    products = ProductPrice.objects.filter(stockLevel__gt=0)
    companylocations = CompanyLocation.objects.all()
    
    for product in products:
        product.stock_value = product.stockLevel * product.selling_price
        
    context = {'products': products, 'companylocations': companylocations, }
    return render(request, 'dashboard/reports/stock_value_report.html', context)





def SalesSummaryReportById(request):

    if request.method == "POST":
        company_location = request.POST.get('companylocation')
        from_date = request.POST.get('from_date')
        to_date = request.POST.get('to_date')
        sale_type = request.POST.get('sale_type')
        
        if sale_type == "Repayment":
            credit_payment = CreditSalePayment
            pass 
        else:
            salesSummary = Sales.objects.all()
            
            if from_date != "":
                salesSummary = salesSummary.filter(sales_date__date__gte=from_date)
                
            if to_date != "":    
                salesSummary = salesSummary.filter(sales_date__date__lte=to_date)    
                
            if company_location != "":
                salesSummary = salesSummary.filter(company_location=company_location)
                
            if sale_type != "":
                salesSummary = salesSummary.filter(sale_type=sale_type)
            
            data = []

            prices = ProductPrice.objects.all()
            
            stock_value = 0
            net_total = 0
            total_discount = 0
            grand_total = 0
            
            for price in prices:
                stock_value += price.stockLevel * price.selling_price
            
            stock_value = stock_value 
            for sale in salesSummary:  
                net_total += sale.net_amount
                total_discount += sale.total_discount
                grand_total += sale.total_amount
            
            data = {"data": [{"grand_total": grand_total, "net_total": net_total, "total_discount": total_discount, "stock_value": stock_value}]}
        
            return JsonResponse(data, safe=False)
    
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
    
    
    

# stock transfer report
def stockTransferReport(request):
    
    stockTransfers = stockTransfer.objects.all()
    companylocations = CompanyLocation.objects.all()
    
    context = {'stockTransfers': stockTransfers, 'companylocations': companylocations}
    return render(request, 'dashboard/reports/stock_transfer_report.html', context)




# stock Purchase report
def stockPurchaseReport(request):
    suppliers = Supplier.objects.all()
    stockTransfers = stockTransfer.objects.all()
    companylocations = CompanyLocation.objects.all()
    
    context = {'stockTransfers': stockTransfers, 'companylocations': companylocations, 'suppliers': suppliers}
    return render(request, 'dashboard/reports/stock_purchase_report.html', context)






# Credit Sale Approval Report
def credit_sale_approval_report(request):
    suppliers = Supplier.objects.all()
    stockTransfers = stockTransfer.objects.all()
    companylocations = CompanyLocation.objects.all()
    users = Acount_User.objects.all()
    sales = CreditSaleApproval.objects.all()
    context = {'stockTransfers': stockTransfers, 'companylocations': companylocations, 'suppliers': suppliers, 'sales':sales, 'users':users}
    return render(request, 'dashboard/reports/credit_sale_approval_report.html', context)



def credit_sale_approval_report_data(request):
    suppliers = Supplier.objects.all()
    stockTransfers = stockTransfer.objects.all()
    companylocations = CompanyLocation.objects.all()
    users = Acount_User.objects.all()
    sales = CreditSaleApproval.objects.all()
    context = {'stockTransfers': stockTransfers, 'companylocations': companylocations, 'suppliers': suppliers, 'sales':sales, 'users':users}
    return render(request, 'dashboard/reports/credit_sale_approval_report.html', context)


# User Activities Report
def user_activities_report(request):
    
    users = Acount_User.objects.all()
    
    return render(request, 'dashboard/reports/user_activities_report.html', context={'users':users})




def user_activities_report_by_id(request):
    if request.method == "POST":
        json_data = json.loads(request.body)
        user = json_data['user']
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        
        user_activities = UserActivitiesReport.objects.all()
        
        if user != "" and not None:
            if user == "all":
                pass
            else:
                user_activities = user_activities.filter(user=user)
            
        
            if from_date != "" and not None:
                user_activities = user_activities.filter(date_created__date__gte=from_date)
            else: 
                user_activities = user_activities.filter(date_created__date=timezone.now().date())
            
            if to_date != "" and not None:
                user_activities = user_activities.filter(date_created__date__lte=to_date)
                
            queryset = user_activities.values('user__username', 'activity', 'date_created')
        
        else:
            queryset = []
    return JsonResponse(list(queryset), status=200, safe=False)






# stock transfer report by id
def salesReportById(request):
    
    if request.method == "POST":
        
        json_data = json.loads(request.body)
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        companylocation = json_data['companylocation']
        sale_type = json_data['sale_type']
        user = json_data['user']
        
        sales = Sales.objects.all()
            
        if from_date != "" and not None:
            sales = sales.filter(sales_date__date__gte=from_date)
        else: 
            sales = sales.filter(sales_date__date=timezone.now().date())
        
        if to_date != "" and not None:
            sales = sales.filter(sales_date__date__lte=to_date)
            
        if companylocation != "" and not None:
            sales = sales.filter(company_location=companylocation)
            
        if sale_type != "" and not None:
            sales = sales.filter(sale_type=sale_type)
            
        if user != "" and not None:
            sales = sales.filter(created_by=user)
             
        queryset = sales.values('id', 'sales_id', 'sales_date', 'total_amount', 'total_discount', 'net_amount', 'paid_amount', 'balance', 'cash', 'momo', 'visa', 'created_by__username', 'company_location__name', 'sale_type', 'customer')
        for data in queryset:
            if data['sale_type'] == "Credit Sale":
                #print(Sales.objects.get(id=int(data['id'])))
                data['customer'] = Sales.objects.get(sales_id=data['sales_id']).credit_customer.name
        return JsonResponse(list(queryset), safe=False)
        
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
    
    
    
    


def salesAndProductReportById(request):
    
    if request.method == "POST":
        
        json_data = json.loads(request.body)
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        companylocation = json_data['companylocation']
        sale_type = json_data['sale_type']
        user = json_data['user']
        
        sales = Sales.objects.all()
            
        if from_date != "" and not None:
            sales = sales.filter(sales_date__date__gte=from_date)
        else: 
            sales = sales.filter(sales_date__date=timezone.now().date())
        
        if to_date != "" and not None:
            sales = sales.filter(sales_date__date__lte=to_date)
            
        if companylocation != "" and not None:
            sales = sales.filter(company_location=companylocation)
            
        if sale_type != "" and not None:
            sales = sales.filter(sale_type=sale_type)
            
        if user != "" and not None:
            sales = sales.filter(created_by=user)
             
        queryset = sales.values('id', 'sales_id', 'sales_date', 'total_amount', 'total_discount', 'net_amount', 'paid_amount', 'balance', 'cash', 'momo', 'sale_type', 'customer')
        for data in queryset:
            if data['sale_type'] == "Credit Sale":
                #print(Sales.objects.get(id=int(data['id'])))
                data['customer'] = Sales.objects.get(sales_id=data['sales_id']).credit_customer.name
                
        # print(queryset)
        new_list = []
        for qset in queryset:
            sales = SalesItem.objects.filter(sales = qset['id'])
            for sale in sales:
                # print(qset['sales_id'], sale)
        
                new_queryset= {
                    'id': qset['id'], 
                    'sales_id': qset['sales_id'], 
                    'sales_date': qset['sales_date'], 
                    'total_amount': qset['total_amount'], 
                    'total_discount': qset['total_discount'], 
                    'net_amount': qset['net_amount'],   
                    'sale_type': qset['sale_type'], 
                    'customer': qset['customer'],
                    'product': sale.product,
                    'unit_price': sale.unit_price,
                    'qty': sale.qty, 
                    'tatal_discount': (sale.unit_discount * int(sale.qty)),
                    'total': (sale.unit_price * int(sale.qty)) - (sale.unit_discount * int(sale.qty))
                }
        
                new_list.append(new_queryset)
        # print(new_list)
        
        return JsonResponse(list(new_list), safe=False)
        
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
 
 
 
   
   
# {'sales_id': 'WS-198', 'sales_date': datetime.datetime(2024, 1, 22, 11, 9, 38, 218244, tzinfo=datetime.timezone.utc), 'total_amount': Decimal('1600.00'), 'total_discount': Decimal('0.00'), 'net_amount': Decimal('1600.00'), 'paid_amount': Decimal('1600.00'), 'balance': Decimal('1600.00'), 'cash': Decimal('1600.00'), 'momo': Decimal('1600.00'), 'sale_type': Decimal('1600.00'), 'customer': Decimal('1600.00'), 'product': 'Rice 25kg', 'unit_price': Decimal('220.00'), 'qty': '5', 'tatal_discount': Decimal('0.00'), 'total': Decimal('1100.00')}

def createSaleApprovalReportById(request):
    
    if request.method == "POST":
        
        json_data = json.loads(request.body)
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        companylocation = json_data['companylocation']
        user = json_data['user']

        sales = CreditSaleApproval.objects.all()
        
        #print(sales)
        if from_date != "" and not None:
            sales = sales.filter(sales_date__date__gte=from_date)
        else: 
            sales = sales.filter(sales_date__date=timezone.now().date())
        
        if to_date != "" and not None:
            sales = sales.filter(sales_date__date__lte=to_date)
            
        if companylocation != "" and not None:
            sales = sales.filter(company_location=companylocation)    
            
        if user != "" and not None:
            sales = sales.filter(created_by=user)
             
        
        queryset = sales.values('id', 'sales_id', 'sales_date', 'total_amount', 'total_discount', 'net_amount', 'paid_amount', 'balance', 'created_by__username', 'company_location__name', 'approved_rejected_by__username', 'credit_customer__name', 'comments__comments', 'status')
        #print(queryset)
        return JsonResponse(list(queryset), safe=False)
        
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
    
    
    
    
    
   

def productSaleReportById(request):
    
    if request.method == "POST":
        json_data = json.loads(request.body)
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        product = json_data['product']
        
        product_purchase = []
        #salesitems = SalesItem.objects.all()

        if product != "" and not None:
            product_price = ProductPrice.objects.filter(id=int(product)).last()
            stocks = Stock.objects.filter(productprice=product_price)
            
            #print("First stock", stocks)
            
            if from_date != "" and not None:
                stocks = stocks.filter(date_created__date__gte=from_date)
            else: 
                stocks = stocks.filter(date_created__date=timezone.now().date())
            
            if to_date != "" and not None:
                stocks = stocks.filter(date_created__date__lte=to_date)
                
            #print("Second Stock", stocks)
            
            for stock in stocks:
                if stock.trans_date == None or stock.trans_date == "": trans_date = "N/A"
                else: trans_date = stock.trans_date
                
                stock.balance
                
                if stock.description == None or stock.description == "": description = "N/A"
                else: description = stock.description
                
                if stock.invoicce_number == None or stock.invoicce_number == "": invoicce_number = "N/A"
                else: invoicce_number = stock.invoicce_number
                
                
                if stock.description != "Cash Sale" or stock.description != "wholesale" or stock.description != "Credit Sale":
                    qty = stock.inward
                else:
                    qty = stock.outward
                nested_list = [trans_date, stock.balance, description, qty]
                #print(stock.trans_date, stock.balance, stock.description, stock.invoicce_number)
                try:
                    sales = Sales.objects.filter(sales_id = stock.invoicce_number).last()
                except:
                    sales = None
                    
                if sales:
                    sales_items = sales.salesitem_set.all()
                else: sales_items = None
                    
                
                if sales:
                    if sales.customer:
                        nested_list.append(sales.customer)
                    elif sales.credit_customer:
                        nested_list.append(sales.credit_customer.name)
                    else:
                        nested_list.append("N/A")
                else:
                    nested_list.append("N/A")
                
                #print(sales_items)
                if sales_items:  
                    for sales_item in sales_items:
                        
                        #print(int(product) == sales_item.productprice_id)
                        if int(product) == sales_item.productprice_id: 
                            nested_list.append(sales_item.unit_price)
                            nested_list.append(sales_item.unit_discount)
                            nested_list.append(sales_item.qty)
                        else: 
                            pass
                            
                else:
                    nested_list.append("N/A")
                    nested_list.append("N/A")
                    nested_list.append("N/A")
                    
                new_len = len(nested_list)
                if new_len != 8:
                    nested_list.append("N/A")
                    nested_list.append("N/A")
                    nested_list.append("N/A")
                    
                product_purchase.append(nested_list)

            #print(product_purchase)
        else:
            return JsonResponse({"error": "Product not found"}, status=400)
        return JsonResponse(product_purchase, safe=False)
    
    return JsonResponse({"error": "Method not allowed"}, status=400)
   
   
   
   
   


# protocol report by ID

def protocolReportById(request):
    
    if request.method == "POST":
        
        json_data = json.loads(request.body)
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        companylocation = json_data['companylocation']
        
        
        sales = Protocol.objects.all()
            
        if from_date != "" and not None:
            sales = sales.filter(sales_date__date__gte=from_date)
        else: 
            sales = sales.filter(sales_date__date=timezone.now().date())
        
        if to_date != "" and not None:
            sales = sales.filter(sales_date__date__lte=to_date)
            
        if companylocation != "" and not None:
            sales = sales.filter(company_location=companylocation)
            
             
        queryset = sales.values('id', 'sales_id', 'sales_date', 'total_amount', 'created_by__username', 'company_location__name', 'customer')
        
        return JsonResponse(list(queryset), safe=False)
        
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
   
   
    

def ApprovalReportById(request):
    
    if request.method == "POST":
        
        json_data = json.loads(request.body)
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        companylocation = json_data['companylocation']
        sale_type = json_data['sale_type']
        user = json_data['user']
        
        sales = CreditSaleApproval.objects.all()
            
        if from_date != "" and not None:
            sales = sales.filter(sales_date__date__gte=from_date)
        
        if to_date != "" and not None:
            sales = sales.filter(sales_date__date__lte=to_date)
            
        if companylocation != "" and not None:
            sales = sales.filter(company_location=companylocation)
            
        if sale_type != "" and not None:
            sales = sales.filter(sale_type=sale_type)
            
        if user != "" and not None:
            sales = sales.filter(created_by=user)
             
        queryset = sales.values('id', 'sales_id', 'sales_date', 'total_amount', 'total_discount', 'net_amount', 'paid_amount', 'balance', 'cash', 'momo', 'visa', 'created_by__username', 'company_location__name', 'sale_type', 'customer')
        return JsonResponse(list(queryset), safe=False)
        
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
    
   
   

    
# stock Transfer report by ID
def stockTransferReportById(request):
    if request.method == "POST":
        
        json_data = json.loads(request.body)
        to_date = json_data['to_date']
        from_date = json_data['from_date']
        from_companylocation = json_data['from_companylocation']
        to_companylocation = json_data['to_companylocation']
        
        
        stock_transfer = stockTransfer.objects.all()
        
        if from_date != "" and not None:
            stock_transfer = stock_transfer.filter(sales_date__date__gte=from_date)
        else:
            stock_transfer = stock_transfer.filter(sales_date__date=timezone.now().date())
        
        if to_date != "" and not None:
            stock_transfer = stock_transfer.filter(sales_date__date__lte=to_date)
            
        if from_companylocation != "" and not None:
            stock_transfer = stock_transfer.filter(from_company=from_companylocation)
            
        if to_companylocation != "" and not None:
            stock_transfer = stock_transfer.filter(to_company=to_companylocation)
            
             
        queryset = stock_transfer.values('stock_transfer_id', 'sales_date', 'from_company__name', 'to_company__name', 'qty', 'product', 'package', 'created_by__username')
        #print(queryset)
        return JsonResponse(list(queryset), safe=False)
        
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
    
    
    

# Stock Purchase report by ID
def stockPurchaseReportById(request):
    if request.method == "POST":
        
        json_data = json.loads(request.body)
        to_date = json_data['to_date']
        from_date = json_data['from_date']
        companylocation = json_data['companylocation']
        supplier = json_data['supplier']
        
        
        
        stock_purchase = stockPurchase.objects.all()
        #print(stock_purchase)
        if from_date != "" and not None:
            stock_purchase = stock_purchase.filter(sales_date__date__gte=from_date)
        else:
            stock_purchase = stock_purchase.filter(sales_date__date=datetime.date.today())
        
        if to_date != "" and not None:
            stock_purchase = stock_purchase.filter(sales_date__date__lte=to_date)
        
            
        if companylocation != "" and not None:
            stock_purchase = stock_purchase.filter(CompanyLocation=companylocation)
            
        if supplier != "" and not None:
            stock_purchase = stock_purchase.filter(supplier=supplier)
            
        queryset = stock_purchase.values('id', 'sales_date', 'CompanyLocation__name', 'stock_purchase_id', 'total_amount', 'total_discount', 'net_amount', 'paid_amount', 'balance', 'supplier__name', 'created_by__username')
        #print(queryset)
        return JsonResponse(list(queryset), safe=False)
        
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
    
    
   
    
    
# Stock Purchase Search by Purchase ID
def stockPurchaseReportByPurchaseId(request):
    if request.method == "POST":
        
        json_data = json.loads(request.body)
        purchase_id = json_data['purchase_id']
        
        #stock_purchase = stockPurchase.objects.all()
        #print(stock_purchase)
        purchase_id_exist = False
        if purchase_id != "" and not None:
            stock_purchase = stockPurchase.objects.filter(id=purchase_id)
            purchase_id_exist = True

        if purchase_id_exist:   
            queryset = stock_purchase.values('id', 'sales_date', 'CompanyLocation__name', 'stock_purchase_id', 'total_amount', 'total_discount', 'net_amount', 'paid_amount', 'balance', 'supplier__name', 'created_by__username')
        else:
            queryset = []
            
        return JsonResponse(list(queryset), safe=False)
        
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
    
 
 
 
 # Stock Purchase Search by Invoice Number
def stockPurchaseReportByInvoice(request):
    if request.method == "POST":
        
        json_data = json.loads(request.body)
        invoice_number = json_data['invoice_number']
        
        #print(stock_purchase)
        if companylocation != "" and not None:
            stock_purchase = stockPurchase.objects.filter(stock_purchase_id__contains=invoice_number)
        else:
            stock_purchase = []
            
            
        queryset = stock_purchase.values('id', 'sales_date', 'CompanyLocation__name', 'stock_purchase_id', 'total_amount', 'total_discount', 'net_amount', 'paid_amount', 'balance', 'supplier__name', 'created_by__username')
        #print(queryset)
        return JsonResponse(list(queryset), safe=False)
        
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
 
 
 
 
 
 
 
 # sales report by sales id   
def salesIdReportById(request):
    
    if request.method == "POST": 
        json_data = json.loads(request.body)
        sale_id = json_data['sale_id']
        sales = Sales.objects.all()
        if sale_id != "" and not None:
            sales = sales.filter(sales_id__contains=sale_id)    
        queryset = sales.values('id', 'sales_id', 'sales_date', 'total_amount', 'total_discount', 'net_amount', 'paid_amount', 'balance', 'cash', 'momo', 'visa', 'created_by__username', 'company_location__name', 'sale_type', 'customer')
        return JsonResponse(list(queryset), safe=False)
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)




# stock tranfer by stock id
def stockTransferIdReportById(request):
    
    if request.method == "POST": 
        json_data = json.loads(request.body)
        transfer_id = json_data['transfer_id']
        stock_transfer = stockTransfer.objects.all()
        if transfer_id != "" and not None:
            stock_transfer = stock_transfer.filter(stock_transfer_id__contains=transfer_id)  
         
        queryset = stock_transfer.values('stock_transfer_id', 'sales_date', 'from_company__name', 'to_company__name', 'qty', 'product', 'package', 'created_by__username')
        #print(queryset)
        return JsonResponse(list(queryset), safe=False)
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)




# stock control report by ID
def stockControlReportById(request):
    
    if request.method == "POST": 
        json_data = json.loads(request.body)
        date = json_data['date']
        product = json_data['product']
        product_price = ProductPrice.objects.filter(id=int(product)).last()
        #queryset = stock.values('trans_date', 'description', 'invoicce_number', 'inward', 'outward', 'balance')
        if product_price:
            stock = Stock.objects.filter(productprice=product_price)
            if date:
                queryset = stock.filter(trans_date__date__gte=date)
                
            else:
                queryset = stock.filter(trans_date__date=datetime.date.today())
                
            queryset = queryset.values('trans_date', 'description', 'invoicce_number', 'inward', 'outward', 'balance')
            return JsonResponse(list(queryset), safe=False)
        else:
            queryset = []
            return JsonResponse(list(queryset), safe=False)
        
    return JsonResponse({"error": "Method not allowed"}, status=400)





# stock Requistion report by ID
def stockRequisitionReportById(request):
    
    if request.method == "POST": 
        json_data = json.loads(request.body)
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        stock_purchase = StockRequisitionReturn.objects.all() 
        
        if from_date and to_date:
            queryset = stock_purchase.filter(date__range=[from_date, to_date])
        else:
            today = datetime.date.today()
            queryset = stock_purchase.filter(date=today)
            
        queryset = queryset.values('balance', 'productprice__product__name', 'id', 'srv_no', 'supplied_to', 'on_account_of', 'qty', 'product_owner', 'recipient', 'cashier', 'stock_keeper', 'date')
        
        return JsonResponse(list(queryset), safe=False)
    
        # else:
        #     queryset = []
        #     return JsonResponse(list(queryset), safe=False)
        
    return JsonResponse({"error": "Method not allowed"}, status=400)











# stock control report by ID
def stockControlSummaryReportById(request):
    
    if request.method == "POST": 
        json_data = json.loads(request.body)
        date = json_data['date']
        product = json_data['product']
        
        if product:
            product_price = ProductPrice.objects.filter(id=int(product)).last()
            #print(product_price)
            if product_price:
                stock = Stock.objects.filter(productprice=product_price)
                if date:
                    stock = stock.filter(trans_date__date__lte=date)
                
                    
                return JsonResponse(list(queryset), safe=False)

            else:
                queryset = []
                return JsonResponse(list(queryset), safe=False)
        queryset = []
        return JsonResponse(list(queryset), safe=False)
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)





# stock Value report by ID
def stockValueReportById(request):
    
    if request.method == "POST": 
        json_data = json.loads(request.body)
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        product = json_data['product']
        total_sold = 0
        total_discount = 0
        unit_discount = 0
        
        
        if product:
            product_price = ProductPrice.objects.filter(id=int(product)) 
            product_sales = SalesItem.objects.all()
            product_sales = product_sales.filter(productprice_id = int(product))
        
            if from_date != "" and not None:
                product_sales = product_sales.filter(date_created__date__gte=from_date)
            else:
                product_sales = product_sales.filter(date_created__date=datetime.date.today())
            
            if to_date != "" and not None:
                product_sales = product_sales.filter(date_created__date__lte=to_date)
            
                
                
            for product in product_sales:
                #print(product.qty, product.unit_discount)
                unit_discount = int(product.qty) * product.unit_discount
                total_sold += (product.unit_price*int(product.qty))-unit_discount
                total_discount += (int(product.qty) * product.unit_discount)
            
            #print(total_sold, total_discount)
            queryset = product_price.values('product__name', 'companylocation__name', 'stockLevel', 'selling_price')
            queryset = list(queryset)
            queryset[0]['total_sold'] = total_sold
            queryset[0]['total_discount'] = total_discount
            return JsonResponse(list(queryset), safe=False)
            

        else:
            queryset = []
            return JsonResponse(list(queryset), safe=False)
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)








def companyLocationById(request):
    
    if request.method == "POST":
        id = json.loads(request.body)
        #print(id)
        location = ProductPrice.objects.filter(companylocation=id).values('id', 'product__name')
        #print(location)
        return JsonResponse(list(location), safe=False)
    
    return JsonResponse({"error": "Method not allowed"}, status=400)






# Customers 

def customer_account_report(request):
    customers = Customer.objects.all()
    
    
    companylocations = CompanyLocation.objects.all()
    credit_sale_payments = CreditSalePayment.objects.all()
    sales = Sales.objects.filter(sale_type="Credit Sale")
    
    opening_balance = 0
    total_credit = 0
    total_paid = 0
    balance = 0
    
    
    
    for customer in customers:
        total = 0
        for sale in sales:
            if sale.credit_customer == customer:
                sales_items = sale.salesitem_set.all()
                for each_sale in sales_items:
                    total += int(each_sale.qty) * (each_sale.unit_price - each_sale.unit_discount) 
        customer.total_credit = total
        customer.save()
        
    
    
    for customer in customers:
        customer.balance = (customer.total_credit + customer.opening_balance) - customer.total_paid
        opening_balance += customer.opening_balance
        total_credit += customer.total_credit
        total_paid += customer.total_paid
        balance += customer.total_credit - customer.total_paid
        
        
        
            
    
        
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("customer_account_report"))
        
        if json_data['customer'] != "":
            customerReport = Customer.objects.get(id=json_data['customer'])
            context = {}
            context['name'] =  customerReport.name
            context['opening_balance'] =  customerReport.opening_balance
            context['total_credit'] =  customerReport.total_credit
            context['total_paid'] =  customerReport.total_paid
            context['balance'] =  customerReport.total_credit - customerReport.total_paid
            #print(context)
           
                
            return JsonResponse(context, safe=False)
    context = {"customers": customers, "companylocations": companylocations, 'opening_balance': opening_balance, 'total_credit': total_credit, 'total_paid': total_paid, 'balance': balance, 'title': 'Customer Account Report'}
    return render(request, 'dashboard/reports/customer_account_report.html', context)




# Customer Statement Report

def customer_statement_report(request):
    customers = Customer.objects.all()
    
    context = {'customers':customers}
    return render(request, 'dashboard/reports/customer_statement_report.html', context)





def invoice(request, sales_id):
    #print(sales_id)
    try: 
        sales = Sales.objects.filter(sales_id=sales_id).first()
        sales_items = sales.salesitem_set.all()
    except:
        messages.error(request, "Cannot generate invoice for this sale!")
        return redirect(reverse('credit_sale_approval_report'))
    
    company_profile = CompanyProfile.objects.filter().first()
    date = datetime.datetime.now()
    
    total_discount = 0
    total_sale = 0
    sub_total = 0
    
    for sale in sales_items:
        total_discount+=(int(sale.qty) * sale.unit_discount)
        total_sale+=(int(sale.qty) * sale.unit_price) - (int(sale.qty) * sale.unit_discount)
        
    sub_total = total_discount + total_sale
        
    
    context = {'company_profile':company_profile, 'sales':sales, 'sales_items':sales_items, 
               'date':date, 'sub_total':sub_total, 'total_discount':total_discount, 'total_sale':total_sale
               }
    
    return render(request, 'dashboard/reports/invoice.html', context)






def customer_statement_report_by_id(request):
    json_body = json.loads(request.body)
    customer = json_body['customer']
    from_date = json_body['from_date']
    to_date = json_body['to_date']
    
    if customer:
        customer = Customer.objects.get(id=customer)
        sales = Sales.objects.filter(credit_customer=customer)
        payments = CreditSalePayment.objects.filter(customer=customer)
        
        if from_date != "" and not None:
            sales = sales.filter(sales_date__date__gte=from_date)
            payments = payments.filter(payment_date__date__gte=from_date)
        else:
            pass
            
        if to_date != "" and not None:
            sales = sales.filter(sales_date__date__lte=to_date)
            payments = payments.filter(payment_date__date__lte=to_date)
        else:
            pass
        
        sales_ctx = []
        payment_ctx = []
        customer_statement = []
        payment_statement = []
        
        for saleitems in sales: 
            sales_items = saleitems.salesitem_set.all()
            for saleitem in sales_items:
                total = int(saleitem.qty) * (saleitem.unit_price - saleitem.unit_discount)
                sales_ctx = [saleitem.date_created, saleitems.id, str(str(saleitem.sales)+ " "+str(saleitem.product) + " "+str(saleitem.package) + " SP:" +str(saleitem.unit_price) + " Qty:" + str(saleitem.qty) + " Dnt:"+ str(saleitem.unit_discount)), total, 0]
                customer_statement.append(sales_ctx)
        
        
        #print(customer_statement)
        
        payment_ctx = [customer.date_created, customer.id, 'Opening Balance', customer.opening_balance, 0]
        customer_statement.append(payment_ctx)
        
        for payment in payments:
            payment_ctx = [payment.payment_date, payment.id, str(payment), 0, payment.amount]
            
            customer_statement.append(payment_ctx)
            
        #customer_statement_report = list(zip(payment_statement, customer_statement))
        
        sorted_data = sorted(customer_statement, key=lambda x: x[0])
        #print(sorted_data)
        return JsonResponse(sorted_data, status=200, safe=False)
            
    return JsonResponse({}, status=200, safe=False)




def customer_account_report_by_id(request):
    json_data = json.loads(request.body)
    customer = json_data['customer']
    from_date = json_data['customer']
    to_date = json_data['customer']

    customer = Customer.objects.get(id=customer)
    
    sales = Sales.objects.filter(credit_customer=customer)
    payments = CreditSalePayment.objects.filter(customer=customer)
    
    
    payment_ctx = {}
    sales_ctx = {}
    
    for payment in payments:
        payment_ctx['date'] = payment.payment_date
        payment_ctx['amount'] = payment.amount
        #payment_ctx['description'] = payments
        payment_ctx['id'] = payment.id
        
    for sale in sales:
        sales_ctx['date'] = sale.sales_date
        sales_ctx['amount'] = sale.net_amount
        #sales_ctx['description'] = sales
        sales_ctx['id'] = sale.id
        
    #print(sales_ctx)
    
    # sorted_dict = dict(sorted(my_dict.items(), key=lambda x: x[1]['date']))
    
    #print(payment_ctx.values())

    return JsonResponse(payment_ctx, status=200, safe=False)






# Supplier Account Report
def supplier_account_report(request):
    customers = Supplier.objects.all()
    
    companylocations = CompanyLocation.objects.all()
    opening_balance = 0
    total_credit = 0
    total_paid = 0
    balance = 0
    
    for customer in customers:
        customer.balance = customer.credit - customer.debit
        total_credit += customer.credit
        total_paid += customer.debit
        balance += customer.credit - customer.debit
    
        
    if request.method == "POST":
        #json_data = json.loads(request.body)
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("supplier_account_report"))
        
        context = {}
        if json_data['customer'] != "":
            customerReport = Supplier.objects.get(id=json_data['customer']) 
            context['name'] =  customerReport.name
            context['total_credit'] =  customerReport.credit
            context['total_paid'] =  customerReport.debit
            context['balance'] =  customerReport.credit - customerReport.debit
            #print(context)
        
                
            return JsonResponse(context, safe=False)
    context = {"customers": customers, "companylocations": companylocations, 'opening_balance': opening_balance, 'total_credit': total_credit, 'total_paid': total_paid, 'balance': balance, 'title': 'Customer Account Report'}
    return render(request, 'dashboard/reports/supplier_account_report.html', context)





def supplier_statement_report(request):
    suppliers = Supplier.objects.all()
    
    context = {'suppliers':suppliers}
    return render(request, 'dashboard/reports/supplier_statement_report.html', context)





# Supplier Statement Report By ID
def supplier_statement_report_by_id(request):
    json_body = json.loads(request.body)
    supplier = json_body['customer']
    from_date = json_body['from_date']
    to_date = json_body['to_date']
    
    if supplier:
        supplier = Supplier.objects.get(id=supplier)
        sales = stockPurchase.objects.filter(supplier=supplier)
        payments = StockPurchasePayment.objects.filter(supplier=supplier)
        
        if from_date != "" and not None:
            sales = sales.filter(sales_date__date__gte=from_date)
            payments = payments.filter(payment_date__date__gte=from_date)
        else:
            pass
            
        if to_date != "" and not None:
            sales = sales.filter(sales_date__date__lte=to_date)
            payments = payments.filter(payment_date__date__lte=to_date)
        else:
            pass
        
        sales_ctx = []
        payment_ctx = []
        customer_statement = []
        payment_statement = []
        
        for saleitems in sales: 
            sales_items = saleitems.stockpurchaseitem_set.all()
            for saleitem in sales_items:
                total = int(saleitem.qty) * (saleitem.unit_price - saleitem.unit_discount)
                sales_ctx = [saleitem.date_created, saleitems.stock_purchase_id, str(str(saleitem.sales)+ " "+str(saleitem.product) + " "+str(saleitem.package) + " SP:" +str(saleitem.unit_price) + " Qty:" + str(saleitem.qty) + " Dnt:"+ str(saleitem.unit_discount)), total, 0]
                customer_statement.append(sales_ctx)
        
        
        #print(customer_statement)
        
        for payment in payments:
            payment_ctx = [payment.payment_date, payment.id, str(payment), 0, payment.amount]
            
            customer_statement.append(payment_ctx)
            
        #customer_statement_report = list(zip(payment_statement, customer_statement))
        
        sorted_data = sorted(customer_statement, key=lambda x: x[0])
        #print(sorted_data)
        return JsonResponse(sorted_data, status=200, safe=False)
            
    return JsonResponse({}, status=200, safe=False)




# Transaction return 
def transaction_return_report(request):
    #transaction_return_report
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.transaction_return_report or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    products = ProductPrice.objects.all()
    

    if request.method == "POST":
        
        #json_data = json.loads(request.body) 
        
        try:
            json_data = json.loads(request.body)
        except:
            messages.error(request, "Please let page finish loading")
            return redirect(reverse("transaction_return_report"))
        
        #print(json_data)
        product = json_data['product']
        from_date = json_data['from_date']
        to_date = json_data['to_date']
        
        stocks = Stock.objects.all()
        
        if from_date != "" and not None:
            stocks = stocks.filter(date_created__date__lte=from_date)
        
        if to_date != "" and not None:
            stocks = stocks.filter(date_created__date__gte=to_date)
            
        
        if product != "" and not None:
            if product == 'all':
                pass
            else:
                productprice = ProductPrice.objects.filter(id=int(product)).last() 
                stocks = stocks.filter(productprice=productprice)
        
        
        stock_list_items = []
        stock_list = []
        
        for stock in stocks:
            if stock.description == "Stock Return":
                stock_list_items = [stock.date_created, str(stock.productprice.product), str(stock.productprice.package), stock.inward, stock.invoicce_number, stock.created_by.username]
                stock_list.append(stock_list_items)
        #print(stock_list)
    
        return JsonResponse(stock_list, status=200, safe=False)
    
    context = {'products':products}
    return render(request, 'dashboard/reports/transaction_return_report.html', context)






#Credit Repayment Report
def creditRepaymentReport(request):
    
    companylocations = CompanyLocation.objects.all()
    customers = Customer.objects.all()
    payments = CreditSalePayment.objects.filter(payment_date__date=timezone.now().date())
    
    context = {'customers': customers, 'companylocations': companylocations, 'payments':payments}

    return render(request, 'dashboard/reports/credit_repayment_report.html', context) 


def creditRepaymentData(request):
    
    payments = CreditSalePayment.objects.all().values(  'id',
                                                        'payment_date__date', 
                                                        'date_created', 
                                                        'customer__name', 
                                                        'amount',
                                                        'paid_by',
                                                        'payment_mode__name',
                                                        'bank__name',
                                                        'bank_branch',
                                                        'cheque_number',
                                                        'cheque_date',
                                                        'created_by__username',
                                                        'company_location__name'
                                                    )
    # print(payments)
    
    return JsonResponse(list(payments), safe=False)




#Expenses Report
def expenseReport(request):
    
    expense_types = ExpenseType.objects.all()
    companylocations = CompanyLocation.objects.all()
    
    context = {'expense_types': expense_types, 'companylocations': companylocations}

    return render(request, 'dashboard/reports/expense_report.html', context) 






# Protocol Report
def protocolReport(request):
    companylocations = CompanyLocation.objects.all()
    sales = Protocol.objects.filter(sales_date__date=datetime.date.today())
    context = {'companylocations': companylocations}
    
    return render(request, 'dashboard/reports/protocol_report.html', context)





# Protocol Id Report By Id
def ProtocolIdReportById(request):
    
    if request.method == "POST": 
        json_data = json.loads(request.body)
        sale_id = json_data['sale_id']
        sales = Protocol.objects.all()
        if sale_id != "" and not None:
            sales = sales.filter(sales_id__contains=sale_id)    
        queryset = sales.values('id', 'sales_id', 'sales_date', 'total_amount',  'created_by__username', 'company_location__name', 'customer')
        return JsonResponse(list(queryset), safe=False)
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)




def bank_transaction_report(request):
    try:
        if request.user.is_superuser and request.user.roles == None:
            pass 
        elif request.user.roles.bank_transaction_report or request.user.is_superuser:
            pass
        else:
            messages.error(request, 'You do not have permission to access this page')
            return redirect(reverse('dashboard'))
    except:
        messages.error(request, 'You do not have permission to access this page')
        return redirect(reverse('dashboard'))
    
    bank_transactions = BankTransaction.objects.all()
    bank_accounts = BankAccounts.objects.all()
    payment_modes = PaymentMode.objects.all()
    expense_types = ExpenseType.objects.all()
    companylocations = CompanyLocation.objects.all()
 
    context = {
        'bank_transactions': bank_transactions,
        'bank_accounts': bank_accounts,
        'payment_modes': payment_modes,
        'expense_types': expense_types,
        'companylocations': companylocations,
    }
    
    
    return render(request, 'dashboard/reports/bank_transaction_report.html', context)







def viewSaleItemById(request):
    id = request.POST.get('id', None)
    sales = Sales.objects.filter(id=id).last()
    
    salesItems = sales.salesitem_set.all()
    # print(list(salesItems.values()))
    return JsonResponse(list(salesItems.values()), safe=False)




# view protocol items by their ID
def viewProtocolItemById(request):
    id = request.POST.get('id', None)
    sales = Protocol.objects.filter(id=id).last()
    
    salesItems = sales.protocolsaleitem_set.all()
    #print(list(salesItems.values()))
    return JsonResponse(list(salesItems.values()), safe=False)





def viewStockPurchaseItemById(request):
    id = request.POST.get('id', None)
    sales = stockPurchase.objects.filter(id=id).last()
    
    salesItems = sales.stockpurchaseitem_set.all()
    #print(list(salesItems.values()))
    return JsonResponse(list(salesItems.values()), safe=False)




def viewSaleApprovalItemById(request):
    id = request.POST.get('id', None)
    sales = CreditSaleApproval.objects.filter(id=id).last()
    
    salesItems = sales.creditsaleapprovalitems_set.all()
    #print(list(salesItems.values()))
    return JsonResponse(list(salesItems.values()), safe=False)






def CreditSaleApprovalIdReportById(request):
    
    if request.method == "POST": 
        json_data = json.loads(request.body)
        sale_id = json_data['sale_id']
        sales = CreditSaleApproval.objects.all()
        if sale_id != "" and not None:
            sales = sales.filter(sales_id__contains=sale_id)    
        queryset = sales.values('id', 'sales_id', 'sales_date', 'total_amount', 'total_discount', 'net_amount', 'paid_amount', 'balance', 'created_by__username', 'company_location__name', 'approved_rejected_by__username', 'credit_customer__name', 'comments__comments', 'status')
        return JsonResponse(list(queryset), safe=False)
    else:
        return JsonResponse({"error": "Method not allowed"}, status=400)
    
    
    
    



def getProductPricesById(request):
    id = request.GET.get('id', None)
    
    productPrice = ProductPrice.objects.filter(companylocation=id)
    context = {}
    data = []
    for price in productPrice:
        product = dict(id=price.id, product=price.product.name)
        data.append(product)
    #print(data)
    return JsonResponse(data, safe=False)
    
    
    
    
    
def viewExpenseReportByID(request):
    
    if request.method == "POST":
        json_body = json.loads(request.body)
        from_date = json_body['from_date']
        to_date = json_body['to_date']
        companylocation = json_body['companylocation']
        expense_type = json_body['expense_type']

        expenses_report = Expenses.objects.all()
        
        #print(expenses_report)
        
        if companylocation != "":
            expenses_report = expenses_report.filter(companylocation=companylocation)
            
        if expense_type != "":
            expenses_report = expenses_report.filter(expense_type=expense_type)
            
        if from_date != "":
            expenses_report = expenses_report.filter(expense_date__date__gte=from_date)
        else:
            expenses_report = expenses_report.filter(expense_date__date=datetime.date.today())
            
        if to_date != "":
            expenses_report = expenses_report.filter(expense_date__date__lte=to_date)
        
        #queryset = expenses_report.values('companylocation__name', 'expense_date', 'expense_type__name', 'description', 'amount', 'payment_mode', 'cheque_number', 'cheque_date', 'bank_account', 'created_by__name')
        queryset = expenses_report.values('companylocation__name', 'expense_date', 'description', 'amount', 'payment_mode__name', 'cheque_number', 'cheque_date', 'bank_account__account_number', 'created_by', 'expense_type__name')
        #print(queryset)
    return JsonResponse(list(queryset), safe=False)








def viewCreditRepaymentReportByID(request):
    
    if request.method == "POST":
        json_body = json.loads(request.body)
        from_date = json_body['from_date']
        to_date = json_body['to_date']
        companylocation = json_body['companylocation']
        customer = json_body['customer']

        credit_repayment = CreditSalePayment.objects.all()
        
        #print(json_body)
        
        if companylocation != "":
            credit_repayment = credit_repayment.filter(company_location=companylocation)
            
        if customer != "":
            credit_repayment = credit_repayment.filter(customer=customer)
            
        if from_date != "":
            credit_repayment = credit_repayment.filter(payment_date__date__gte=from_date)
        else:
            credit_repayment = credit_repayment.filter(payment_date__date=datetime.date.today())
            
        if to_date != "":
            credit_repayment = credit_repayment.filter(payment_date__date__lte=to_date)
        
        #queryset = expenses_report.values('companylocation__name', 'expense_date', 'expense_type__name', 'description', 'amount', 'payment_mode', 'cheque_number', 'cheque_date', 'bank_account', 'created_by__name')
        queryset = credit_repayment.values('payment_date__date', 'date_created__date', 'customer__name', 'company_location__name', 'amount', 'payment_mode__name', 'cheque_number', 'cheque_date', 'created_by__username', 'paid_by', 'bank__name', 'bank_branch')
        #print(queryset)

    return JsonResponse(list(queryset), safe=False)






def search_cashsale_products(request):
    
    if request.method == "POST":
        json_body = json.loads(request.body)
        search_productsprice = json_body['search_productsprice']
        #print(json_body)
        products = ProductPrice.objects.all()
        if search_productsprice != "" and not None:
            products = products.filter(product__name__contains=search_productsprice,  stockLevel__gte=1, sale_type='retail')    
        else:
            products = products.filter(stockLevel__gte=1, sale_type='retail')
        queryset = products.values('id', 'product__name',)
        #print(queryset)
        return JsonResponse(list(queryset), safe=False)

    return JsonResponse(list(queryset), safe=False)





def search_wholesale_products(request):
    
    if request.method == "POST":
        json_body = json.loads(request.body)
        search_productsprice = json_body['search_productsprice']
        #print(json_body)
        products = ProductPrice.objects.all()
        if search_productsprice != "" and not None:
            products = products.filter(product__name__contains=search_productsprice,  stockLevel__gte=1, sale_type='wholesale')    
        else:
            products = products.filter(stockLevel__gte=1, sale_type='wholesale')
        queryset = products.values('id', 'product__name',)
        #print(queryset)
        return JsonResponse(list(queryset), safe=False)

    return JsonResponse(list(queryset), safe=False)




def search_products_location(request):
    
    if request.method == "POST":
        json_body = json.loads(request.body)
        
        search_productsprice = json_body['search_productsprice']
        from_companylocation = json_body['from_companylocation']
        #print(from_companylocation)
        products = ProductPrice.objects.all()
        if search_productsprice != "" and not None:
            products = products.filter(product__name__contains=search_productsprice,  stockLevel__gte=1, companylocation=from_companylocation)    
        else:
            products = products.filter(stockLevel__gte=1, companylocation=from_companylocation)
        queryset = products.values('id', 'product__name',)

        return JsonResponse(list(queryset), safe=False)

    return JsonResponse(list(queryset), safe=False)




def search_palet_by_product(request):
    
    if request.method == "POST":
        #print(request.body)
        #id = json.loads(request.body)
        id = request.POST.get('id')
        #print(id)
        palet = BatchPaleting.objects.filter(product=id, active=True).values('id', 'batch_number')
        #print(list(palet))
        return JsonResponse(list(palet), safe=False)
    
    return JsonResponse({"error": "Method not allowed"}, status=400)
    
    
    
    

def add_pallet(request):
    if request.method == "POST":
        
        json_data = json.loads(request.body)
        #print(json_data)
        sale_id = json_data['sale_id']
        batch_number1 = json_data['batch_number1']
        batch_number2 = json_data['batch_number2']
        #print(sale_id, batch_number1, batch_number2)
        if sale_id:
            if batch_number1:
                palet= BatchPaleting.objects.filter(id=batch_number1).first()
                SalesItem.objects.filter(id=sale_id).update(batch_number1=palet)
            if batch_number2:
                palet= BatchPaleting.objects.filter(id=batch_number2).first()
                SalesItem.objects.filter(id=sale_id).update(batch_number2=palet)
            return JsonResponse({"success": "Palet added successfully"}, status=200)
        return JsonResponse({"error": "Method not allowed"}, status=400)
    
    return JsonResponse({"error": "Method not allowed"}, status=400)











